dict(
    art='Bundesstatistik',
    berichtsjahr=2022,
    datensatz_laenge=237,
    core_csv_positionen=76,
    idev_csv_positionen=75,
    statistik_items=[
        dict(
            art='Item',
            name='EndeMonatHilfe',
            ebkus_name='em',
            typ='Ganzzahl',
            feldlaenge=2,
            minimum=1,
            maximum=12,
            datensatz_position=(219, 220),
            core_csv_position=33,
            idev_csv_position=67,
            wireb_csv_position=33,
            wireb_name='EndeMonatHilfe',
            idev_name='Ende der Hilfegewährung Monat',
            core_langname='Ende der Hilfegewährung Monat',
            nur_bei_beendet=True,
        ),
        dict(
            art='Item',
            name='Geschlecht',
            ebkus_name='gs',
            typ='Option',
            optionsgruppe='gs',
            feldlaenge=1,
            datensatz_position=(113, 113),
            core_csv_position=13,
            idev_csv_position=46,
            wireb_csv_position=13,
            wireb_name='Geschlecht',
            idev_name='Geschlecht des jungen Menschenwenn Familienorientierte Hilfe = Nein',
            core_langname='Geschlecht bei nicht Familienhilfe',
            optionen=[
                dict(
                    text='männlich',
                    code='1',
                ),
                dict(
                    text='weiblich',
                    code='2',
                ),
                dict(
                    text='divers',
                    code='3',
                ),
                dict(
                    text='ohne Angabe (nach Geburtenregister)',
                    code='7',
                ),
            ],
        ),
        dict(
            art='Item',
            name='ZahlKontakteEnde',
            ebkus_name='nbkges',
            typ='Ganzzahl',
            feldlaenge=3,
            minimum=1,
            maximum=999,
            datensatz_position=(225, 227),
            core_csv_position=35,
            idev_csv_position=69,
            wireb_csv_position=35,
            wireb_name='ZahlKontakteEnde',
            idev_name='Bei Erziehungsberatung: Zahl der Beratungskontakte während der gesamten Beratungsdauer',
            core_langname='Bei Erziehungsberatung: Zahl der Beratungskontakte während der gesamten Beratungsdauer (beendete Hilfen/Beratungen)',
            nur_bei_beendet=True,
        ),
        dict(
            art='Item',
            name='J2Leer',
            ebkus_name='j2leer',
            typ='Zeichenkette',
            feldlaenge=4,
            fester_wert='    ',
            datensatz_position=(209, 212),
            core_csv_position=(28, 29),
            idev_csv_position=(62, 63),
            wireb_name='J2Leer',
            idev_namen=('Vereinbarte Leistungsstunden pro Wochesofern diese stundenweise abgerechnet werden', 'Vereinbarte Leistungstage pro Woche'),
            core_namen=('ZahlLeistungsstunden', 'ZahlLeistungstage'),
        ),
        dict(
            art='Item',
            name='KontaktAnregung',
            ebkus_name='aip',
            typ='Option',
            optionsgruppe='aip',
            feldlaenge=1,
            datensatz_position=(201, 201),
            core_csv_position=22,
            idev_csv_position=56,
            wireb_csv_position=22,
            wireb_name='Kontaktanregung',
            idev_name='Diese aktuelle Hilfe anregende Institution/Person',
            core_langname='Diese akt. Hilfe anregende Inst. / Person',
            optionen=[
                dict(
                    text='Junger Mensch selbst',
                    code='1',
                ),
                dict(
                    text='Eltern bzw. Personensorgeberechtigte/r',
                    code='2',
                ),
                dict(
                    text='Schule/Kindertageseinrichtung',
                    code='3',
                ),
                dict(
                    text='Soziale/r Dienst/e und andere Institution/en (z.B. Jugendamt)',
                    code='4',
                ),
                dict(
                    text='Gericht/Staatsanwaltschaft/Polizei',
                    code='5',
                ),
                dict(
                    text='Arzt/Klinik/Gesundheitsamt',
                    code='6',
                ),
                dict(
                    text='Ehemalige Klienten/Bekannte',
                    code='7',
                ),
                dict(
                    text='Sonstige',
                    code='8',
                ),
            ],
        ),
        dict(
            art='Item',
            name='EndeJahrHilfe',
            ebkus_name='ey',
            typ='Ganzzahl',
            feldlaenge=4,
            minimum=1970,
            maximum=2030,
            datensatz_position=(221, 224),
            core_csv_position=34,
            idev_csv_position=68,
            wireb_csv_position=34,
            wireb_name='EndeJahrHilfe',
            idev_name='Ende der Hilfegewährung Jahr',
            core_langname='Ende der Hilfegewährung jahr',
            nur_bei_beendet=True,
        ),
        dict(
            art='Item',
            name='UebernahmeVonAnderemJugendamt',
            ebkus_name='zustw',
            typ='Checkbox',
            feldlaenge=1,
            vorgabe_wert='0',
            checked_wert='1',
            datensatz_position=(103, 103),
            core_csv_position=7,
            idev_csv_position=8,
            wireb_csv_position=7,
            wireb_name='UebernahmeVonAnderemJugendamt',
            idev_name='Übernahme von einem anderen Jugendamt wegen Zuständigkeitswechsel',
            core_langname='Übernahme von einem anderen Jugendamt wegen Zuständigkeitswechsel',
            optional=True,
        ),
        dict(
            art='Item',
            name='LetzterKontakt',
            ebkus_name='lbk6m',
            typ='Option',
            optionsgruppe='ja_nein',
            feldlaenge=1,
            datensatz_position=(228, 228),
            core_csv_position=36,
            idev_csv_position=70,
            wireb_csv_position=36,
            wireb_name='LetzterKontakt',
            idev_name='Letzter Beratungskontakt liegt mehr als 6 Monate zurück nicht im Formular',
            core_langname='Letzter Beratungskontakt liegt mehr als 6 Monate zurück',
            nur_bei_beendet=True,
            optionen=[
                dict(
                    text='ja',
                    code='1',
                ),
                dict(
                    text='nein',
                    code='2',
                ),
            ],
        ),
        dict(
            art='Item',
            name='Schulbesuch',
            ebkus_name='aktuellbesuchteausbildungsstaette',
            typ='Zeichenkette',
            feldlaenge=2,
            fester_wert='  ',
            datensatz_position=(199, 200),
            core_csv_position=43,
            idev_csv_position=55,
            wireb_name='AktuellBesuchteAusbildungsstaette',
            idev_name='Aktuell besuchte Schule oder Ausbildungsstätte',
            core_langname='Aktuell besuchte Schule oder Ausbildungsstätte',
        ),
        dict(
            art='Item',
            name='RichtGenehm',
            ebkus_name='rgu',
            typ='Option',
            optionsgruppe='ja_nein',
            feldlaenge=1,
            vorgabe_wert='2',
            datensatz_position=(204, 204),
            core_csv_position=25,
            idev_csv_position=59,
            wireb_csv_position=25,
            wireb_name='RichtGenehm',
            idev_name='Richterliche Genehmigung für Unterbringungdie mit Freiheitsentzug verbunden ist',
            core_langname='Richterliche Genehmigung für Unterbringung, die mit Freiheitsentzug verbunden ist',
            optionen=[
                dict(
                    text='ja',
                    code='1',
                ),
                dict(
                    text='nein',
                    code='2',
                ),
            ],
        ),
        dict(
            art='Item',
            name='BerichtseinheitID',
            ebkus_name='berichtseinheitid',
            typ='Zeichenkette',
            feldlaenge=14,
            datensatz_position=(2, 15),
            core_langname='Gemeindeschluessel (Land = ALN2, Regierungsbezirk = ALN1, Kreis = ALN2, Gemeinde = ALN3) und Einrichtungsnummer (6)',
            readonly=True,
            berechnet=True,
        ),
        dict(
            art='Item',
            name='LaufendeNummer',
            ebkus_name='lnr',
            typ='Ganzzahl',
            feldlaenge=5,
            datensatz_position=(16, 20),
            wireb_csv_position=1,
            wireb_name='LaufendeNummer',
            readonly=True,

        ),
        dict(
            art='Item',
            name='Filter3',
            ebkus_name='hilfeausserhalbelternhaus',
            typ='Zeichenkette',
            feldlaenge=1,
            fester_wert='2',
            datensatz_position=(198, 198),
            core_csv_position=46,
            idev_csv_position=54,
            wireb_name='HilfeAusserhalbElternhaus',
            idev_name='Hilfe außerhalb des Elternhauses aus dem Bereich § 27 Absatz 13 und 4 oder §§ 29 und 3032 bis 35a und 41 SGB VIII',
            core_langname='Hilfe außerhalb des Elternhauses aus dem Bereich § 27 Absatz 1, 3 und 4 oder §§ 29 und 30, 32 bis 35a und 41 SGB VIII',
        ),
        dict(
            art='Item',
            name='KennNr',
            ebkus_name='extra_kennnummer',
            typ='Zeichenkette',
            feldlaenge=20,
            datensatz_position=(21, 40),
            core_csv_position=1,
            idev_csv_position=1,
            wireb_name='Kennnummer',
            idev_name='Kennnummer',
            core_langname='Kennnummer des jungen Menschen (ab 2022 neu bezeichnet)',
            berechnet=True,
        ),
        dict(
            art='Item',
            name='GrundEndeHilfe',
            ebkus_name='grende',
            typ='Option',
            optionsgruppe='grende',
            feldlaenge=2,
            datensatz_position=(233, 234),
            core_csv_position=39,
            idev_csv_position=73,
            wireb_csv_position=39,
            wireb_name='GrundEndeHilfe',
            idev_name='Grund für die Beendigung der Hilfe/Beratung',
            core_langname='Grund für die Beendigung der Hilfe/Beratung',
            nur_bei_beendet=True,
            optionen=[
                dict(
                    text='Beendigung gemäß Hilfeplan/Beratungszielen',
                    code='10',
                ),
                dict(
                    text='Beendigung abweichend von Hilfeplan/Beratungszielen durch den Sorgeberechtigten/den jungen Volljährigen (auch durch unzureichende Mitwirkung)',
                    code='20',
                ),
                dict(
                    text='Beendigung abweichend von Hilfeplan/Beratungszielen durch die bisher betreuende Einrichtung, die Pflegefamilie, den Dienst',
                    code='21',
                ),
                dict(
                    text='Beendigung abweichend von Hilfeplan/Beratungszielen durch den Minderjährigen',
                    code='22',
                ),
                dict(
                    text='Adoptionspflege/Adoption',
                    code='30',
                ),
                dict(
                    text='Abgabe an ein anderes Jugendamt wegen Zuständigkeitswechsels',
                    code='40',
                ),
                dict(
                    text='Sonstige Gründe',
                    code='50',
                ),
            ],
        ),
        dict(
            art='Item',
            name='TraegerEinrichtung',
            ebkus_name='traeger',
            typ='Option',
            optionsgruppe='traeger',
            feldlaenge=2,
            vorgabe_wert='10',
            datensatz_position=(110, 111),
            core_csv_position=12,
            idev_csv_position=13,
            wireb_csv_position=12,
            wireb_name='TraegerEinrichtung',
            idev_name='Träger der Einrichtung',
            core_langname='Träger der Einrichtung',
            optionen=[
                dict(
                    text='Träger der öffentlichen Jugendhilfe',
                    code='10',
                ),
                dict(
                    text='Arbeiterwohlfahrt oder deren Mitgliedsorganisation',
                    code='21',
                ),
                dict(
                    text='Deutscher Paritätischer Wohlfahrtsverband oder dessen Mitgliedsorganisation',
                    code='22',
                ),
                dict(
                    text='Deutsches Rotes Kreuz oder dessen Mitgliedsorganisation',
                    code='23',
                ),
                dict(
                    text='Diakonisches Werk oder sonstiger der EKD angeschlossener Träger',
                    code='24',
                ),
                dict(
                    text='Deutscher Caritasverband oder sonstiger katholischer Traeger',
                    code='25',
                ),
                dict(
                    text='Zentralwohlfahrtsinstitut der Juden in Deutschland oder jüdische Kultusgemeinde',
                    code='26',
                ),
                dict(
                    text='Sonstige Religionsgemeinschaft des öffentlichen Rechts',
                    code='27',
                ),
                dict(
                    text='Sonstiger anerkannter Träger der Jugendhilfe',
                    code='28',
                ),
                dict(
                    text='Sonstige juristische Person, andere Vereinigung',
                    code='29',
                ),
                dict(
                    text='Wirtschaftsunternehmen (privat-gewerblich)',
                    code='30',
                ),
                dict(
                    text='Pflegefamilie, die Vollzeitpflege gemäß §33 SGB VIII durchführt',
                    code='40',
                ),
            ],
        ),
        dict(
            art='Item',
            name='GeburtJahr',
            ebkus_name='gey',
            typ='Ganzzahl',
            feldlaenge=4,
            minimum=1970,
            maximum=2040,
            datensatz_position=(116, 119),
            core_csv_position=15,
            idev_csv_position=48,
            wireb_csv_position=15,
            wireb_name='GeburtJahr',
            idev_name='Geburtsjahr des jungen Menschenwenn Familienorientierte Hilfe = Nein',
            core_langname='Geburtsjahr bei nicht Familienhilfe',
        ),
        dict(
            art='Item',
            name='SituationHerkunft',
            ebkus_name='sit_fam',
            typ='Option',
            optionsgruppe='shf',
            feldlaenge=1,
            datensatz_position=(194, 194),
            core_csv_position=18,
            idev_csv_position=50,
            wireb_csv_position=18,
            wireb_name='SituationHerkunft',
            idev_name='Situation in der Herkunftsfamilie',
            core_langname='Situation in der Herkunftsfamilie',
            optionen=[
                dict(
                    text='Eltern leben zusammen',
                    code='1',
                ),
                dict(
                    text='Elternteil lebt alleine ohne (Ehe-)Partner/in',
                    code='2',
                ),
                dict(
                    text='Elternteil lebt mit neuer Partnerin/neuem Partner (z.B. Stiefelternkonstellation)',
                    code='3',
                ),
                dict(
                    text='Eltern sind verstorben',
                    code='4',
                ),
                dict(
                    text='Unbekannt',
                    code='5',
                ),
            ],
        ),
        dict(
            art='Item',
            name='GerichtlAnordnung',
            ebkus_name='va52',
            typ='Option',
            optionsgruppe='ja_nein',
            feldlaenge=1,
            vorgabe_wert='2',
            datensatz_position=(203, 203),
            core_csv_position=24,
            idev_csv_position=58,
            wireb_csv_position=24,
            wireb_name='GerichtlAnordnung',
            idev_name='Gerichtliche Anordnung',
            core_langname='Gerichtliche Anordnung Der Beratung (nach § 156 Abs. 1 Satz 4 FamFG)',
            optionen=[
                dict(
                    text='ja',
                    code='1',
                ),
                dict(
                    text='nein',
                    code='2',
                ),
            ],
        ),
        dict(
            art='Item',
            name='Filter1',
            ebkus_name='extra_mehrere_hilfen',
            typ='Zeichenkette',
            feldlaenge=1,
            datensatz_position=(41, 41),
            core_csv_position=44,
            idev_csv_position=2,
            wireb_name='MehrereHilfen',
            idev_name='Mehrere Einzelhilfen zum Zeitpunkt der Meldung',
            core_langname='Mehrere Hilfen zum Zeitpunkt der Meldung',
            berechnet=True,
        ),
        dict(
            art='Item',
            name='M2Leer',
            ebkus_name='m2leer',
            typ='Zeichenkette',
            feldlaenge=4,
            fester_wert='    ',
            datensatz_position=(229, 232),
            core_csv_position=(37, 38),
            idev_csv_position=(71, 72),
            wireb_name='M2Leer',
            idev_namen=('Vereinbarte Leistungsstunden pro Woche', 'Vereinbarte Leistungstage pro Woche'),
            core_namen=('ZahlLeistungsstundenEnde', 'ZahlLeistungstageEnde'),
        ),
        dict(
            art='Item',
            name='Gefaehrdungseinschaetzung',
            ebkus_name='gef8a',
            typ='Option',
            optionsgruppe='ja_nein',
            feldlaenge=1,
            datensatz_position=(104, 104),
            core_csv_position=8,
            idev_csv_position=9,
            wireb_csv_position=8,
            wireb_name='Gefaehrdungseinschaetzung',
            idev_name='Wurde die Hilfe auf Grund einer vorangegangenen Gefährdungseinschätzung eingeleitet?',
            core_langname='Einleitung der Hilfe aufgrund vorangeg. Gefährdungseinschätzung',
            optionen=[
                dict(
                    text='ja',
                    code='1',
                ),
                dict(
                    text='nein',
                    code='2',
                ),
            ],
        ),
        dict(
            art='Item',
            name='PLZWohnortdesBeratenen',
            ebkus_name='plz',
            typ='Zeichenkette',
            feldlaenge=5,
            datensatz_position=(52, 56),
            core_csv_position=3,
            idev_csv_position=4,
            wireb_csv_position=3,
            wireb_name='PLZWohnortdesBeratenen',
            idev_name='Postleitzahl des Wohnorts des/der Beratenen',
            core_langname='Postleitzahl',
            berechnet=True,
            optional=True,
        ),
        dict(
            art='Item',
            name='BA',
            ebkus_name='ba',
            typ='Zeichenkette',
            feldlaenge=1,
            fester_wert='A',
            datensatz_position=(1, 1),
            wireb_name='BA',
        ),
        dict(
            art='Item',
            name='SozialSicherung',
            ebkus_name='wirt_sit',
            typ='Option',
            optionsgruppe='ja_ne_un',
            feldlaenge=1,
            datensatz_position=(197, 197),
            core_csv_position=21,
            idev_csv_position=53,
            wireb_csv_position=21,
            wireb_name='SozialSicherung',
            idev_name='Die Herkunftsfamilie/der junge Volljährige lebt teilweise oder ganz von Transferleistungen oder bezieht einen Kinderzuschlag',
            core_langname='Die Herkunftsfamile/der junge Volljährige lebt teilweise oder ganz von Arbeitslosengeld, Grundsicherung im Alter und bei Erwerbsminderung oder Sozialhilfe (SGBXII) oder bezieht einen Kinderzuschlag',
            optional=True,
            optionen=[
                dict(
                    text='unbekannt',
                    code='0',
                ),
                dict(
                    text='ja',
                    code='1',
                ),
                dict(
                    text='nein',
                    code='2',
                ),
            ],
        ),
        dict(
            art='Item',
            name='AnschlAufenthalt',
            ebkus_name='aort_nac',
            typ='Option',
            optionsgruppe='auf_ort',
            feldlaenge=2,
            datensatz_position=(235, 236),
            core_csv_position=40,
            idev_csv_position=74,
            wireb_csv_position=40,
            wireb_name='AnschlAufenthalt',
            idev_name='Anschliessender Aufenthalt',
            core_langname='Anschliessender Aufenthalt',
            nur_bei_beendet=True,
            optionen=[
                dict(
                    text='Im Haushalt der Eltern/eines Elternteils/des Sorgeberechtigten',
                    code='01',
                ),
                dict(
                    text='In einer Verwandtenfamilie',
                    code='02',
                ),
                dict(
                    text='In einer nicht.verwandten Familie (z.B. Pflegestelle nach § 44 SGB VIII)',
                    code='03',
                ),
                dict(
                    text='In der eigenen Wohnung',
                    code='04',
                ),
                dict(
                    text='In einer Pflegefamilie nach §§ 33, 35a, 41 SGB VIII',
                    code='05',
                ),
                dict(
                    text='In einem Heim oder einer betreuten Wohnform nach §§ 34, 35a, 41 SGB VIII',
                    code='06',
                ),
                dict(
                    text='In der Psychiatrie',
                    code='07',
                ),
                dict(
                    text='In einer sozialpädagogisch betreuten Einrichtung (z.B. Internat, Mutter-/Vater-Kind Einrichtung)',
                    code='08',
                ),
                dict(
                    text='Sonstiger Aufenthalt (z.B. JVA, Frauenhaus)',
                    code='09',
                ),
                dict(
                    text='Ohne feste Unterkunft',
                    code='10',
                ),
                dict(
                    text='Unbekannt/keine Angabe möglich',
                    code='11',
                ),
            ],
        ),
        dict(
            art='Item',
            name='AuslaendHerkunft',
            ebkus_name='ausl_her',
            typ='Option',
            optionsgruppe='ja_ne_un',
            feldlaenge=1,
            datensatz_position=(195, 195),
            core_csv_position=19,
            idev_csv_position=51,
            wireb_csv_position=19,
            wireb_name='AuslaendHerkunft',
            idev_name='Ausländische Herkunft mindestens eines Elternteils',
            core_langname='Ausländische Herkunft mindestens eines Elternteils',
            optional=True,
            optionen=[
                dict(
                    text='unbekannt',
                    code='0',
                ),
                dict(
                    text='ja',
                    code='1',
                ),
                dict(
                    text='nein',
                    code='2',
                ),
            ],
        ),
        dict(
            art='Item',
            name='E2E3Leer',
            ebkus_name='e2e3leer',
            typ='Zeichenkette',
            feldlaenge=72,
            fester_wert='                                                                        ',
            datensatz_position=(120, 191),
            core_csv_position=(16, 47, 48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63, 64, 65, 66, 67, 68, 69, 70, 71, 72, 73, 74, 75, 76),
            idev_csv_position=(45, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44),
            wireb_name='E2E3Leer',
            idev_namen=('Zahl der minderj\xe4hrigen Kinderdie au\xdferhalb der Familie untergebracht sind', 'Geschlecht des 1. Kindes', 'Geburtsmonat des 1. Kindes', 'Geburtsjahr des 1. Kindes', 'Geschlecht des 2. Kindes', 'Geburtsmonat des 2. Kindes', 'Geburtsjahr des 2. Kindes', 'Geschlecht des 3. Kindes', 'Geburtsmonat des 3. Kindes', 'Geburtsjahr des 3. Kindes', 'Geschlecht des 4. Kindes', 'Geburtsmonat des 4. Kindes', 'Geburtsjahr des 4. Kindes', 'Geschlecht des 5. Kindes', 'Geburtsmonat des 5. Kindes', 'Geburtsjahr des 5. Kindes', 'Geschlecht des 6. Kindes', 'Geburtsmonat des 6. Kindes', 'Geburtsjahr des 6. Kindes', 'Geschlecht des 7. Kindes', 'Geburtsmonat des 7. Kindes', 'Geburtsjahr des 7. Kindes', 'Geschlecht des 8. Kindes', 'Geburtsmonat des 8. Kindes', 'Geburtsjahr des 8. Kindes', 'Geschlecht des 9. Kindes', 'Geburtsmonat des 9. Kindes', 'Geburtsjahr des 9. Kindes', 'Geschlecht des 10. Kindes', 'Geburtsmonat des 10. Kindes', 'Geburtsjahr des 10. Kindes'),
            core_namen=('ZahlKinderAusserhalbFamilie', 'Geschlecht_GAF[1]', 'GeburtMonat_GAF[1]', 'GeburtJahr_GAF[1]', 'Geschlecht_GAF[2]', 'GeburtMonat_GAF[2]', 'GeburtJahr_GAF[2]', 'Geschlecht_GAF[3]', 'GeburtMonat_GAF[3]', 'GeburtJahr_GAF[3]', 'Geschlecht_GAF[4]', 'GeburtMonat_GAF[4]', 'GeburtJahr_GAF[4]', 'Geschlecht_GAF[5]', 'GeburtMonat_GAF[5]', 'GeburtJahr_GAF[5]', 'Geschlecht_GAF[6]', 'GeburtMonat_GAF[6]', 'GeburtJahr_GAF[6]', 'Geschlecht_GAF[7]', 'GeburtMonat_GAF[7]', 'GeburtJahr_GAF[7]', 'Geschlecht_GAF[8]', 'GeburtMonat_GAF[8]', 'GeburtJahr_GAF[8]', 'Geschlecht_GAF[9]', 'GeburtMonat_GAF[9]', 'GeburtJahr_GAF[9]', 'Geschlecht_GAF[10]', 'GeburtMonat_GAF[10]', 'GeburtJahr_GAF[10]'),
        ),
        dict(
            art='Item',
            name='ZahlKontakte',
            ebkus_name='nbkakt',
            typ='Ganzzahl',
            feldlaenge=3,
            minimum=1,
            maximum=999,
            datensatz_position=(206, 208),
            core_csv_position=27,
            idev_csv_position=61,
            wireb_csv_position=27,
            wireb_name='ZahlKontakte',
            idev_name='Bei Erziehungsberatung: Zahl der Beratungskontakte im abgelaufenen Kalenderjahr',
            core_langname='Bei Erziehungsberatung: Zahl der Beratungskontakte',
            nur_bei_andauernd=True,
        ),
        dict(
            art='Item',
            name='GeburtMonat',
            ebkus_name='gem',
            typ='Ganzzahl',
            feldlaenge=2,
            minimum=1,
            maximum=12,
            datensatz_position=(114, 115),
            core_csv_position=14,
            idev_csv_position=47,
            wireb_csv_position=14,
            wireb_name='GeburtMonat',
            idev_name='Geburtsmonat des jungen Menschenwenn Familienorientierte Hilfe = Nein',
            core_langname='Geburtsmonat bei nicht Familienhilfe',
        ),
        dict(
            art='Item',
            name='ArtHilfe',
            ebkus_name='hilf_art',
            typ='Option',
            optionsgruppe='hilf_art',
            feldlaenge=2,
            datensatz_position=(106, 107),
            core_csv_position=10,
            idev_csv_position=11,
            wireb_csv_position=10,
            wireb_name='ArtHilfe',
            idev_name='Art der Hilfe',
            core_langname='Art der Hilfe',
            optionen=[
                dict(
                    text='Erziehungsberatung vorrangig mit der Familie (Eltern und Kind)',
                    code='01',
                ),
                dict(
                    text='Erziehungsberatung vorrangig mit den Eltern (zusammen oder einzeln)',
                    code='02',
                ),
                dict(
                    text='Erziehungsberatung vorrangig mit dem jungen Menschen',
                    code='03',
                ),
            ],
        ),
        dict(
            art='Item',
            name='ZweiterGrund',
            ebkus_name='gr2',
            typ='Option',
            optionsgruppe='gruende',
            feldlaenge=2,
            datensatz_position=(215, 216),
            core_csv_position=31,
            idev_csv_position=65,
            wireb_csv_position=31,
            wireb_name='ZweiterGrund',
            idev_name='Gründe für die Hilfegewährung Zweiter Grund',
            core_langname='Gründe für die Hilfegewährung, zweiter Grund',
            optional=True,
        ),
        dict(
            art='Item',
            name='DritterGrund',
            ebkus_name='gr3',
            typ='Option',
            optionsgruppe='gruende',
            feldlaenge=2,
            datensatz_position=(217, 218),
            core_csv_position=32,
            idev_csv_position=66,
            wireb_csv_position=32,
            wireb_name='DritterGrund',
            idev_name='Gründe für die Hilfegewährung Dritter Grund',
            core_langname='Gründe für die Hilfegewährung, dritter Grund',
            optional=True,
        ),
        dict(
            art='Item',
            name='HauptgrundHilfegewaehrung',
            ebkus_name='gr1',
            typ='Option',
            optionsgruppe='gruende',
            feldlaenge=2,
            datensatz_position=(213, 214),
            core_csv_position=30,
            idev_csv_position=64,
            wireb_csv_position=30,
            wireb_name='HauptgrundHilfegewaehrung',
            idev_name='Gründe für die Hilfegewährung Hauptgrund',
            core_langname='Gründe für die Hilfegewährung, Hauptgruund',
            optionen=[
                dict(
                    text='Unversorgtheit des jungen Menschen<br>(z.B. Ausfall der Bezugspersonen wegen Krankheit, stationärer Unterbringung, Inhaftierung, Tod; unbegleitet eingereiste Minderjährige)',
                    code='10',
                ),
                dict(
                    text='Unzureichende Förderung/Betreuung/Versorgung des jungen Menschen in der Familie<br>(z.B. soziale, gesundheitliche, wirtschaftliche Probleme)',
                    code='11',
                ),
                dict(
                    text='Gefährdung des Kindeswohls<br>(z.B. Vernachlässigung, körperliche, psychische, sexuelle Gewalt in der Familie)',
                    code='12',
                ),
                dict(
                    text='Eingeschränkte Erziehungskompetenz der Eltern/Personensorgeberechtigten<br>(z.B. Erziehungsunsicherheit, pädagogische Überforderung, unangemessene Verwöhnung)',
                    code='13',
                ),
                dict(
                    text='Belastungen des jungen Menschen durch Problemlagen der Eltern<br>(z.B. psychische Erkrankung, Suchtverhalten, geistige oder seelische Behinderung)',
                    code='14',
                ),
                dict(
                    text='Belastungen des jungen Menschen durch familiäre Konflikte<br>(z.B. Partnerkonflikte, Trennung und Scheidung, Umgangs-/Sorgerechtsstreitigkeiten, Eltern-/Stiefeltern-Kind-Konflikte, migrationsbedingte Konfliktlagen)',
                    code='15',
                ),
                dict(
                    text='Auffälligkeiten im sozialen Verhalten (dissoziales Verhalten) des jungen Menschen<br>(z.B. Gehemmtheit, Isolation, Geschwisterrivalität, Weglaufen, Aggressivität, Drogen-/Alkoholkonsum, Delinquenz/Straftat)',
                    code='16',
                ),
                dict(
                    text='Entwicklungsauffälligkeiten/seelische Probleme des jungen Menschen<br>(z.B. Entwicklungsrückstand, Ängste, Zwänge, selbst verletzendes Verhalten, suizidale Tendenzen)',
                    code='17',
                ),
                dict(
                    text='Schulische/beruflische Probleme des jungen Menschen<br>(z.B. Schwierigkeiten mit Leistungsanforderungen, auch durch Hochbegabung, Konzentrationsprobleme ADS, Hyperaktivität, schulvermeidendes Verhalten, Schulschwänzen)',
                    code='18',
                ),
                dict(
                    text='Übernahme von einem anderen Jugendamt wegen Zuständigkeitswechsels',
                    code='19',
                ),
            ],
        ),
        dict(
            art='Item',
            name='Lfdnr_Hilfe',
            ebkus_name='extra_hilfen_lnr',
            typ='Zeichenkette',
            feldlaenge=2,
            datensatz_position=(42, 43),
            core_csv_position=42,
            wireb_name='LaufendeNummerEinzelhilfe',
            core_langname='Laufende Nummer dieser Hilfe',
            berechnet=True,
        ),
        dict(
            art='Item',
            name='OrtDurchfuehrung',
            ebkus_name='hilf_ort',
            typ='Option',
            optionsgruppe='hilf_ort',
            feldlaenge=2,
            vorgabe_wert='06',
            datensatz_position=(108, 109),
            core_csv_position=11,
            idev_csv_position=12,
            wireb_csv_position=11,
            wireb_name='OrtDurchfuehrung',
            idev_name='Ort der Durchführung',
            core_langname='Hauptsächlicher Ort der Durchführung',
            optionen=[
                dict(
                    text='In der Wohnung der Herkunftsfamilie/Adoptivfamilie',
                    code='01',
                ),
                dict(
                    text='In (der Wohnung) einer Verwandtenfamilie',
                    code='02',
                ),
                dict(
                    text='In einer Einrichtung der Kindertagesbetreuung',
                    code='04',
                ),
                dict(
                    text='In der Schule',
                    code='05',
                ),
                dict(
                    text='In den Räumen eines ambulaten Dienstes/einer Beratungsstelle',
                    code='06',
                ),
                dict(
                    text='Per Telefon',
                    code='13',
                ),
                dict(
                    text='Über das Internet (z.B. Chatberatung, Videokonferenz)',
                    code='14',
                ),
                dict(
                    text='Sonstiger Ort (z.B. JVA, Klinik, Frauenhaus)',
                    code='12',
                ),
            ],
        ),
        dict(
            art='Item',
            name='BeginnMonatHilfe',
            ebkus_name='bgm',
            typ='Ganzzahl',
            feldlaenge=2,
            minimum=1,
            maximum=12,
            datensatz_position=(97, 98),
            core_csv_position=5,
            idev_csv_position=6,
            wireb_csv_position=5,
            wireb_name='BeginnMonatHilfe',
            idev_name='Beginn der Hilfegewährung Monat',
            core_langname='Beginn der Hilfegewährung Monat',
        ),
        dict(
            art='Item',
            name='EntzugSorge',
            ebkus_name='ees',
            typ='Option',
            optionsgruppe='ja_nein',
            feldlaenge=1,
            vorgabe_wert='2',
            datensatz_position=(202, 202),
            core_csv_position=23,
            idev_csv_position=57,
            wireb_csv_position=23,
            wireb_name='EntzugSorge',
            idev_name='Entzug der elterlichen Sorge',
            core_langname='Teilweise oder vollständiger Entzug der elterlichen Sorge',
            optionen=[
                dict(
                    text='ja',
                    code='1',
                ),
                dict(
                    text='nein',
                    code='2',
                ),
            ],
        ),
        dict(
            art='Item',
            name='SpracheDeutsch',
            ebkus_name='vor_dt',
            typ='Option',
            optionsgruppe='ja_ne_un',
            feldlaenge=1,
            datensatz_position=(196, 196),
            core_csv_position=20,
            idev_csv_position=52,
            wireb_csv_position=20,
            wireb_name='SpracheDeutsch',
            idev_name='In der Familie wird vorrangig deutsch gesprochen',
            core_langname='In der Familie wird vorrangig deutsch gesprochen',
            optional=True,
            optionen=[
                dict(
                    text='unbekannt',
                    code='0',
                ),
                dict(
                    text='ja',
                    code='1',
                ),
                dict(
                    text='nein',
                    code='2',
                ),
            ],
        ),
        dict(
            art='Item',
            name='AndauerHilfeJahresende',
            ebkus_name='hda',
            typ='Option',
            optionsgruppe='ja_nein',
            feldlaenge=1,
            datensatz_position=(205, 205),
            core_csv_position=26,
            idev_csv_position=60,
            wireb_csv_position=26,
            wireb_name='AndauerHilfeJahresende',
            idev_name='Hilfe/Beratung dauert am Jahresende an',
            core_langname='Hilfe / Beratung dauert am Jahresende an',
            optionen=[
                dict(
                    text='ja',
                    code='1',
                ),
                dict(
                    text='nein',
                    code='2',
                ),
            ],
        ),
        dict(
            art='Item',
            name='NachfolgendeHilfe',
            ebkus_name='unh',
            typ='Option',
            optionsgruppe='unh',
            feldlaenge=1,
            datensatz_position=(237, 237),
            core_csv_position=41,
            idev_csv_position=75,
            wireb_csv_position=41,
            wireb_name='NachfolgendeHilfe',
            idev_name='Unmittelbar nachfolgende Hilfe',
            core_langname='Unmittelbar nachfolgende Hilfe',
            nur_bei_beendet=True,
            optionen=[
                dict(
                    text='Zuständigkeitswechsel:Fortführung in derselben Pflegefamilie bzw. Einrichtung',
                    code='1',
                ),
                dict(
                    text='Weiterverweisung an Eheberatung, Schuldnerberatung, Kinder- und Jugendlichenpsychotherapeuten, andere Einrichtungen (§§ 17-21 SGB VIII)',
                    code='2',
                ),
                dict(
                    text='Beratung in allgemeinen Fragen der Erziehung durch den Allgemeinen Sozialdienst (ASD) (§16 Abs.2 Nr.2 SGB VIII)',
                    code='3',
                ),
                dict(
                    text='Hilfe zur Erziehung gemäß §§27-35, 41 SGB VIII',
                    code='4',
                ),
                dict(
                    text='Eingliederungshilfe gemäß §35a SGB VIII',
                    code='5',
                ),
                dict(
                    text='Keine unmittelbar nachfolgende Hilfe nach dem SGB VIII bekannt',
                    code='6',
                ),
            ],
        ),
        dict(
            art='Item',
            name='BeginnJahrHilfe',
            ebkus_name='bgy',
            typ='Ganzzahl',
            feldlaenge=4,
            minimum=1970,
            maximum=2030,
            datensatz_position=(99, 102),
            core_csv_position=6,
            idev_csv_position=7,
            wireb_csv_position=6,
            wireb_name='BeginnJahrHilfe',
            idev_name='Beginn der Hilfegewährung Jahr',
            core_langname='Beginn der Hilfegewährung Jahr',
        ),
        dict(
            art='Item',
            name='WohnortdesBeratenen',
            ebkus_name='ort',
            typ='Zeichenkette',
            feldlaenge=40,
            datensatz_position=(57, 96),
            core_csv_position=4,
            idev_csv_position=5,
            wireb_csv_position=4,
            wireb_name='WohnortdesBeratenen',
            idev_name='Wohnort des/der Beratenen',
            core_langname='Wohnort',
            berechnet=True,
            optional=True,
        ),
        dict(
            art='Item',
            name='AGSWohnortdesBeratenen',
            ebkus_name='ags',
            typ='Zeichenkette',
            feldlaenge=8,
            datensatz_position=(44, 51),
            core_csv_position=2,
            idev_csv_position=3,
            wireb_csv_position=2,
            wireb_name='AGSWohnortdesBeratenen',
            idev_name='Amtlicher Gemeindeschlüssel des Wohnortes des/der Beratenen bei Erziehungsberatung',
            core_langname='Amtlicher Gemeindeschlüssel des Wohnortes des Beratenen bei Erziehungsberatung falls nicht im selben Kreis wie Beratungsstelle liegend',
            berechnet=True,
            optional=True,
        ),
        dict(
            art='Item',
            name='Inobhutnahme',
            ebkus_name='inobh42_22',
            typ='Option',
            optionsgruppe='inobh42',
            feldlaenge=1,
            datensatz_position=(105, 105),
            core_csv_position=9,
            idev_csv_position=10,
            wireb_csv_position=9,
            wireb_name='Schutzmassnahme',
            idev_name='Einleitung der Hilfe im Anschluss an eine Inobhutnahme (§ 42 Absatz 1 SGB VIII)',
            core_langname='Einleitung der Hilfe im Anschluss an eine Inobhutnahme (§ 42 Absatz 1 SGB VIII)',
            optionen=[
                dict(
                    text='Ja, aufgrund einer unbegleiteten Einreise aus dem Ausland (§ 42 Absatz 1 Satz 1 Nummer 3 SGB VIII)',
                    code='1',
                ),
                dict(
                    text='Ja, aufgrund einer dringenden Kindeswohlgefährdung (§ 42 Absatz 1 Satz 1 Nummer 2 SGB VIII)',
                    code='2',
                ),
                dict(
                    text='Ja, aufgrund der Bitte des Kindes/Jugendlichen um Inobhutnahme (§ 42 Absatz 1 Satz 1 Nummer 1 SGB VIII)',
                    code='3',
                ),
                dict(
                    text='Nein, zuvor wurde keine Inobhutnahme durchgeführt',
                    code='4',
                ),
            ],
        ),
        dict(
            art='Item',
            name='AufentOrtVorHilfe',
            ebkus_name='aort_vor',
            typ='Option',
            optionsgruppe='auf_ort',
            feldlaenge=2,
            datensatz_position=(192, 193),
            core_csv_position=17,
            idev_csv_position=49,
            wireb_csv_position=17,
            wireb_name='AufentOrtVorHilfe',
            idev_name='Aufenthaltsort der Hilfeempfänger vor der Hilfe',
            core_langname='Aufenthaltsort der Hilfeempfänger vor der Hilfe',
            optionen=[
                dict(
                    text='Im Haushalt der Eltern/eines Elternteils/des Sorgeberechtigten',
                    code='01',
                ),
                dict(
                    text='In einer Verwandtenfamilie',
                    code='02',
                ),
                dict(
                    text='In einer nicht.verwandten Familie (z.B. Pflegestelle nach § 44 SGB VIII)',
                    code='03',
                ),
                dict(
                    text='In der eigenen Wohnung',
                    code='04',
                ),
                dict(
                    text='In einer Pflegefamilie nach §§ 33, 35a, 41 SGB VIII',
                    code='05',
                ),
                dict(
                    text='In einem Heim oder einer betreuten Wohnform nach §§ 34, 35a, 41 SGB VIII',
                    code='06',
                ),
                dict(
                    text='In der Psychiatrie',
                    code='07',
                ),
                dict(
                    text='In einer sozialpädagogisch betreuten Einrichtung (z.B. Internat, Mutter-/Vater-Kind Einrichtung)',
                    code='08',
                ),
                dict(
                    text='Sonstiger Aufenthalt (z.B. JVA, Frauenhaus)',
                    code='09',
                ),
                dict(
                    text='Ohne feste Unterkunft',
                    code='10',
                ),
                dict(
                    text='Unbekannt/keine Angabe möglich',
                    code='11',
                ),
            ],
        ),
        dict(
            art='Item',
            name='Filter2',
            ebkus_name='familienorientiertehilfe',
            typ='Zeichenkette',
            feldlaenge=1,
            fester_wert='2',
            datensatz_position=(112, 112),
            core_csv_position=45,
            idev_csv_position=14,
            wireb_name='FamilienOrientierteHilfe',
            idev_name='Familienorientierte Hilfe (Sozialpädagogische Familienhilfe nach § 31 SGB VIII bzw. familienorientierte Hilfe nach § 27 Absatz 2 SGB VIII)',
            core_langname='Familienorientierte Hilfe (Sozialpädagogische Familienhilfe nach § 31 SGB VIII bzw. familienorientierte Hilfe nach § 27 Absatz 2 SGB VIII)',
        ),
    ],
    fragebogen_elemente=[
        dict(
            art='Abschnitt',
            gliederung='A',
            titel='Beginn und Anlass der Hilfegewährung',
            teile=[
                dict(
                    art='Eingabe',
                    item='BeginnMonatHilfe',
                    text='Monat (der Einleitung der Hilfe)',
                ),
                dict(
                    art='Eingabe',
                    item='BeginnJahrHilfe',
                    text='Jahr',
                ),
                dict(
                    art='Eingabe',
                    item='UebernahmeVonAnderemJugendamt',
                    text='Übernahme von einem anderen Jugendamt wegen Zuständigkeitswechsels',
                ),
                dict(
                    art='Eingabe',
                    item='Gefaehrdungseinschaetzung',
                    text='Einleitung der Hilfe aufgrund einer vorangegangenen Gefährdungseinschätzung (§ 8a Absatz 1 SGB VIII)',
                ),
                dict(
                    art='Eingabe',
                    item='Inobhutnahme',
                    text='Einleitung der Hilfe im Anschluss an eine Inobhutnahme (§42 Absatz 1 Satz 1 SGB VIII)',
                ),
            ],
        ),
        dict(
            art='Abschnitt',
            gliederung='B',
            titel='Art der Hilfe',
            teile=[
                dict(
                    art='Eingabe',
                    item='ArtHilfe',
                    text='Art der Hilfe',
                ),
            ],
        ),
        dict(
            art='Abschnitt',
            gliederung='C',
            titel='Ort der Durchführung',
            teile=[
                dict(
                    art='Eingabe',
                    item='OrtDurchfuehrung',
                    text='Ort an dem die Hilfe (hauptsächlich) durchgeführt wird',
                ),
            ],
        ),
        dict(
            art='Abschnitt',
            gliederung='D',
            titel='Träger',
            teile=[
                dict(
                    art='Eingabe',
                    item='TraegerEinrichtung',
                    text='Träger der Einrichtung oder des Dienstes, die/der die Hilfe/Beratung durchführt',
                ),
            ],
        ),
        dict(
            art='Abschnitt',
            gliederung='E',
            titel='Geschlecht, Geburtsmonat und -jahr',
            teile=[
                dict(
                    art='Eingabe',
                    item='Geschlecht',
                    text='Geschlecht, nach (Geburtenregister)',
                ),
                dict(
                    art='Eingabe',
                    item='GeburtMonat',
                    text='Geburtsmonat',
                ),
                dict(
                    art='Eingabe',
                    item='GeburtJahr',
                    text='Geburtsjahr',
                ),
            ],
        ),
        dict(
            art='Abschnitt',
            gliederung='F',
            titel='Lebenssituation bei Beginn der Hilfe',
            teile=[
                dict(
                    art='Eingabe',
                    item='AufentOrtVorHilfe',
                    text='Gewöhnlicher Aufenthaltsort vor der Hilfe',
                ),
                dict(
                    art='Eingabe',
                    item='SituationHerkunft',
                    text='Situation in der Herkunftsfamilie',
                ),
                dict(
                    art='Eingabe',
                    item='AuslaendHerkunft',
                    text='Ausländische Herkunft mindestens eines Elternteils (nicht: Staatsangehörigkeit)',
                ),
                dict(
                    art='Eingabe',
                    item='SpracheDeutsch',
                    text='In der Familie wird vorrangig deutsch gesprochen',
                ),
                dict(
                    art='Eingabe',
                    item='SozialSicherung',
                    text='Die Familie bzw. die/der junge Volljährige lebt teilweise oder ganz von <ul><li>Arbeitslosengeld (nach dem Zweiten Buch Sozialgesetzbuch - SGB II), auch in Verbindung mit Sozialgeld,</li><li>Sozialhilfe oder Grundsicherungsleistungen im Alter und bei Erwerbsminderung (nach dem Zwölften Buch Sozialgesetzbuch - SGB XII),</li><li>einem Kinderzuschlag</li></ul>',
                ),
            ],
        ),
        dict(
            art='Abschnitt',
            gliederung='G',
            titel='Anregende Institution oder Person',
            teile=[
                dict(
                    art='Eingabe',
                    item='KontaktAnregung',
                    text='Diese aktuelle Hilfe/Beratung anregende(n) Institution(en) oder Person(en) (Hinweisgeber)',
                ),
            ],
        ),
        dict(
            art='Abschnitt',
            gliederung='H',
            titel='Familienrichterliche Entscheidungen im Zusammenhang mit der <b>aktuellen Hilfe</b>',
            teile=[
                dict(
                    art='Eingabe',
                    item='EntzugSorge',
                    text='Teilweiser oder vollständiger Entzug der elterlichen Sorge (nach §1666 BGB)',
                ),
                dict(
                    art='Eingabe',
                    item='GerichtlAnordnung',
                    text='Gerichtliche Anordnung der Beratung (nach §156 Absatz 1 Satz 4 FamFG)',
                ),
                dict(
                    art='Eingabe',
                    item='RichtGenehm',
                    text='Richterliche Genehmigung für eine freiheitsentziehende Unterbringung/Maßnahme (nach §1631b BGB)',
                ),
            ],
        ),
        dict(
            art='Abschnitt',
            gliederung='I',
            titel='Hilfe dauert an',
            teile=[
                dict(
                    art='Eingabe',
                    item='AndauerHilfeJahresende',
                    text='Hilfe/Beratung dauert am Jahresende an',
                ),
            ],
        ),
        dict(
            art='Abschnitt',
            gliederung='J',
            titel='Intensität der am Jahresende andauernden Hilfe/Beratung',
            teile=[
                dict(
                    art='Zwischentext',
                    text='(Nur ausfüllen, falls die Hilfe/Beratung am Jahresende andauert)',
                    fett=True,
                ),
                dict(
                    art='Eingabe',
                    item='ZahlKontakte',
                    text='Zahl der Beratungskontakte im abgelaufenen Kalenderjahr',
                ),
            ],
        ),
        dict(
            art='Abschnitt',
            gliederung='K',
            titel='Gründe für die Hilfegewährung',
            teile=[
                dict(
                    art='EingabeK',
                    text='Gründe (bitte 1 - 3 Gründe ankreuzen)',
                    headers=('Hauptgrund', '2. Grund', '3. Grund'),
                    items=('HauptgrundHilfegewaehrung', 'ZweiterGrund', 'DritterGrund'),
                ),
            ],
        ),
        dict(
            art='ZwischenAbschnittText',
            gliederung='Zwischen',
            text='Nachfolgende Angaben bitte zusätzlich beim Ende der Hilfe/Beratung ausfüllen.',
        ),
        dict(
            art='Abschnitt',
            gliederung='L',
            titel='Ende der Hilfe/Beratung',
            teile=[
                dict(
                    art='Eingabe',
                    item='EndeMonatHilfe',
                    text='Monat',
                ),
                dict(
                    art='Eingabe',
                    item='EndeJahrHilfe',
                    text='Jahr',
                ),
            ],
        ),
        dict(
            art='Abschnitt',
            gliederung='M',
            titel='Betreuungsintensität der beendeten Hilfe/Beratung',
            teile=[
                dict(
                    art='Eingabe',
                    item='ZahlKontakteEnde',
                    text='Zahl der Beratungskontakte während der gesamten Beratungsdauer',
                ),
                dict(
                    art='Eingabe',
                    item='LetzterKontakt',
                    text='Letzter Beratungskontakt liegt mehr als sechs Monate zurück',
                ),
            ],
        ),
        dict(
            art='Abschnitt',
            gliederung='N',
            titel='Grund für die Beendigung der Hilfe/Beratung',
            teile=[
                dict(
                    art='Eingabe',
                    item='GrundEndeHilfe',
                    text='Grund für die Beendigung der Hilfe/Beratung',
                ),
            ],
        ),
        dict(
            art='Abschnitt',
            gliederung='O',
            titel='Anschließender Aufenthalt',
            teile=[
                dict(
                    art='Eingabe',
                    item='AnschlAufenthalt',
                    text='Anschließender Aufenthalt',
                ),
            ],
        ),
        dict(
            art='Abschnitt',
            gliederung='P',
            titel='Unmittelbar nachfolgende Hilfe',
            teile=[
                dict(
                    art='Eingabe',
                    item='NachfolgendeHilfe',
                    text='Unmittelbar nachfolgende Hilfe',
                ),
            ],
        ),
    ],
)
