# coding: latin-1
"""
Weitgehend obsolet. Ersetzt durch die deklarative Bundesstatistikdefinition
und den Modulen jghdef und jghexport2.

Es greift nur noch wireb auf dieses Modul zu, das noch nicht auf
jghdef angepasst ist. Wireb scheint auch keiner zu benutzen, ich 
habe jedenfalls noch keinerlei Rckmeldung bekommen.

Falls Wireb eine Zukunft hat, kann man das noch umstellen.


Routinen fr die Erzeugung des amtlichen Datensatzes
fr die Bundesjugendhilfestatistik

Die Funktion jghexport(jahr) gibt zwei Strings zurck:

- den abzugebenden Datensatz ohne Zeilenumbrche
- den Kontrolldatensatz mit Zeilenumbrchen und der zustzlichen
  Angabe der Fallnummer und der Mitarbeiterkennung pro Fall

Die Funktion wird vom Webinterface (html/datenaustausch.py) benutzt, um
dem Anwender zu ermglichen, den abzugebenen Datensatz und den
Kontrolldatensatz herunterzuladen.

Auerdem kann diese Datei als Skript verwendet werden, um die Datenstze
direkt als Dateien ohne Umweg ber das Webinterface zu erzeugen.
Dazu ist diese Datei (jghexport.py) in das Verzeichnis der Instanz
zu kopieren, fr die die Statistik erzeugt werden soll.

Aufruf:

python jghexport.py <jahr>

python sollte zum Aufruf desselben Interpreters fhren, mit dem EBKuS
installiert wurde.
"""


if __name__ == '__main__':
    import sys
    try:
        import init
    except ImportError:
        print "Dieses Skript zuerst in das Verzeichnis der Instanz kopieren,"
        print "fuer die der JGH-Export durchgefuehrt werden soll."
        sys.exit(1)
        
from ebkus.config import config
from ebkus.app.ebapi import FallList, JugendhilfestatistikList, Jugendhilfestatistik2007List, \
    today, EE
from ebkus.app.ebupd import jgh_laufende_nummer_setzen
from ebkus.html.jghstatistik import get_ags_plz_ort_if_wohnort_ausserhalb
from ebkus.app.ebapi import cc

# Die SQL-Variante unten ist viel schneller, also das hier nur noch aus historischen Grnden...
def get_daten_fuer_uebersicht(berichtsjahr):
    """Basis sind alle Flle, die zu irgendeinem Zeitpunkt im Berichtsjahr offen
    waren.

        Im Berichtsjahr 2018 gab es 2772 Flle, davon 1150 bernahmen aus 2017 und 1650 
        Neuaufnahmen.

                                       bernahmen  Neuaufnahmen  Insgesamt ohne Fall
        Flle im Berichtsjahr:

                                               mit zdA  ohne zdA  exportieren  zu klren  insgesamt ohne Fall (nur falls vorhanden)
                                                                   
        Bundesstatistik mit Eintrag 
        Ende der Hilfe/Beratung 2018              234     123         236         123         432      2        

        Bundesstatistik mit Eintrag
        Hilfe/Beratung dauert an fr 2018           0     344         345           0         345      1
        
        Keine Bundesstatistik vorhanden             0      23           0          23          23

        Sonstige                                  123      23           0          23         146

        Summe                                    


                           Button        Problematische Flle anzeigen

                                                                                        
                           Fallnummer    Beginn (Anmeldung) letzte Zustndigkeit    zdA   Bundesstatistik  fortdauernd
                                                                                          Berichtsjahr
                           123-2016HAU     02.08.2016              Tester          offen         2017           ja


        Abgeschlossene Flle im Berichtsjahr:

                                                      
        Fordauernde Flle am Ende des Berichtsjahrs: 

        

    """
    class data(object):
        def __init__(self, **kw):
            for k,v in kw.items():
                setattr(self, k, v)
    jahr = berichtsjahr
    # ohne Fall
    BS_ohne_fall_andauernd = Jugendhilfestatistik2007List(where='fall_id is NULL and ey is null and jahr = {jahr}'.format(**locals()))
    sum_BS_ohne_fall_andauernd = len(BS_ohne_fall_andauernd)
    BS_ohne_fall_beendet = Jugendhilfestatistik2007List(where='fall_id is NULL and ey = {jahr}'.format(**locals()))
    sum_BS_ohne_fall_beendet = len(BS_ohne_fall_beendet)
    BS_ohne_fall_beendet += JugendhilfestatistikList(where='fall_id is NULL and ey = {jahr}'.format(**locals()))
    sum_BS_ohne_fall_beendet = len(BS_ohne_fall_beendet)
    # faelle, die im Berichtsjahr irgendwann offen waren
    faelle = FallList(where = 'bgy<={jahr} and '
                      '(zday >= {jahr} or zday = 0)'.format(**locals()), 
                      cache_related=True)
    sum_faelle = len(faelle)
    sum_uebernahmen = len([f for f in faelle if f['bgy'] < jahr])
    sum_neuaufnahmen = sum_faelle - sum_uebernahmen

    BS_Berichtsjahr_beendet = [f for f in faelle if f['jgh'] and f['jgh__ey']==jahr]
    sum_BS_Berichtsjahr_beendet = len(BS_Berichtsjahr_beendet)
    BS_Berichtsjahr_beendet_mit_zda = [f for f in BS_Berichtsjahr_beendet if f['zday'] > 0]
    sum_BS_Berichtsjahr_beendet_mit_zda = len(BS_Berichtsjahr_beendet_mit_zda)
    BS_Berichtsjahr_andauernd = [f for f in faelle if f['jgh'] and f['jgh__ey']==None and f['jgh__hda__code']=='1' and f['jgh__jahr']==jahr]
    sum_BS_Berichtsjahr_andauernd = len(BS_Berichtsjahr_andauernd)
    BS_fehlt = [f for f in faelle if f['jgh']==None]
    sum_BS_fehlt = len(BS_fehlt)


    BS_sonstige = [f for f in faelle if f['jgh'] and ((f['jgh__ey']!=None and f['jgh__ey']!=jahr) or (f['jgh__ey']==None and f['jgh__jahr']!=jahr))]
    sum_BS_sonstige = len(BS_sonstige)

    BS_sonstige_zda = [f for f in BS_sonstige if f['zday'] > 0]
    sum_BS_sonstige_zda = len(BS_sonstige_zda)
    sum_BS_sonstige_ohne_zda = sum_BS_sonstige - sum_BS_sonstige_zda

    res = data(
        sum_BS_ohne_fall_andauernd=sum_BS_ohne_fall_andauernd,
        sum_BS_ohne_fall_beendet=sum_BS_ohne_fall_beendet,
        sum_BS_ohne_fall=sum_BS_ohne_fall_andauernd + sum_BS_ohne_fall_beendet,
        sum_faelle=sum_faelle,
        sum_uebernahmen=sum_uebernahmen,
        sum_neuaufnahmen=sum_neuaufnahmen,
        sum_BS_Berichtsjahr_beendet=sum_BS_Berichtsjahr_beendet,
        sum_BS_Berichtsjahr_beendet_mit_zda=sum_BS_Berichtsjahr_beendet_mit_zda,
        sum_BS_Berichtsjahr_andauernd=sum_BS_Berichtsjahr_andauernd,
        sum_BS_fehlt=sum_BS_fehlt,
        sum_BS_sonstige=sum_BS_sonstige,
        sum_BS_sonstige_zda=sum_BS_sonstige_zda,
        sum_BS_sonstige_ohne_zda=sum_BS_sonstige_ohne_zda,
        )

    assert (
        sum_BS_Berichtsjahr_beendet +
        sum_BS_Berichtsjahr_andauernd +
        sum_BS_fehlt +
        sum_BS_sonstige
        == 
        sum_faelle
        )
    print
    print 'Berichtsjahr: ', berichtsjahr
    print '======================'
    print
    for k,v in res.__dict__.items():
        print k,v

    return res

def get_daten_fuer_uebersicht_sql(berichtsjahr):
    """Basis sind alle Flle, die zu irgendeinem Zeitpunkt im Berichtsjahr offen
    waren.

        Im Berichtsjahr 2018 gab es 2772 Flle, davon 1150 bernahmen aus 2017 und 1650 
        Neuaufnahmen.

                                       bernahmen  Neuaufnahmen  Insgesamt ohne Fall
        Flle im Berichtsjahr:

                                               mit zdA  ohne zdA  exportieren  zu klren  insgesamt ohne Fall (nur falls vorhanden)
                                                                   
        Bundesstatistik mit Eintrag 
        Ende der Hilfe/Beratung 2018              234     123         236         123         432      2        

        Bundesstatistik mit Eintrag
        Hilfe/Beratung dauert an fr 2018           0     344         345           0         345      1
        
        Keine Bundesstatistik vorhanden             0      23           0          23          23

        Sonstige                                  123      23           0          23         146

        Summe                                    


                           Button        Problematische Flle anzeigen

                                                                                        
                           Fallnummer    Beginn (Anmeldung) letzte Zustndigkeit    zdA   Bundesstatistik  fortdauernd
                                                                                          Berichtsjahr
                           123-2016HAU     02.08.2016              Tester          offen         2017           ja


        Abgeschlossene Flle im Berichtsjahr:

                                                      
        Fordauernde Flle am Ende des Berichtsjahrs: 

        

    """
    class Data(object):
        def __init__(self, **kw):
            for k,v in kw.items():
                setattr(self, k, v)
        def __str__(self):
            return str(self.__dict__)
    def get_count(result_dict_list, counters, **kw):
        for counter_name in kw.keys():
            setattr(counters, counter_name, 0)
        for row_dict in result_dict_list:
            mygroup = row_dict.get('mygroup')
            mycount = row_dict.get('mycount')
            for counter_name, group_name in kw.items():
                if mygroup == group_name:
                    setattr(counters, counter_name, mycount)
    jahr = berichtsjahr
    counters = Data()
    from ebkus.db.sql import getDBHandle
    # ohne Fall
    sql = """
SELECT count(j.id) as mycount, c.name as mygroup
FROM jghstat07 j
     INNER JOIN code c ON j.hda = c.id
WHERE j.fall_id is null and (j.jahr = {jahr} or j.ey = {jahr})
GROUP BY mygroup
""".format(jahr=jahr)
    res = getDBHandle().query(sql, dictionary=True)
    get_count(res, counters, sum_BS_ohne_fall_andauernd='ja', sum_BS_ohne_fall_beendet='nein')
    counters.sum_BS_ohne_fall = counters.sum_BS_ohne_fall_beendet + counters.sum_BS_ohne_fall_andauernd

    # Flle
    sql = """
SELECT count(f.bgy) as mycount, IF(f.bgy<{jahr}, 'ueber', 'neu') as mygroup
FROM fall f
WHERE f.bgy <= {jahr} and (f.zday >= {jahr} or f.zday = 0)
GROUP BY mygroup
""".format(jahr=jahr)
    res = getDBHandle().query(sql, dictionary=True)
    get_count(res, counters, sum_uebernahmen='ueber',sum_neuaufnahmen='neu')
    counters.sum_faelle = counters.sum_uebernahmen + counters.sum_neuaufnahmen


    # Flle beendet mit/ohne zdA

    sql = """
SELECT count(f.id) as mycount, IF(f.zday > 0, 'mit_zda', 'ohne_zda') as mygroup
FROM fall f INNER JOIN jghstat07 j ON f.id = j.fall_id
WHERE f.bgy <= {jahr} and (f.zday >= {jahr} or f.zday = 0) and j.ey = {jahr}
GROUP BY mygroup
""".format(jahr=jahr)
    res = getDBHandle().query(sql, dictionary=True)
    get_count(res, counters, sum_BS_Berichtsjahr_beendet_mit_zda='mit_zda',sum_BS_Berichtsjahr_beendet_ohne_zda='ohne_zda')
    counters.sum_BS_Berichtsjahr_beendet = counters.sum_BS_Berichtsjahr_beendet_mit_zda + counters.sum_BS_Berichtsjahr_beendet_ohne_zda

    # Flle andauernd

    sql = """
SELECT count(f.id) as mycount, c.name as mygroup
FROM fall f INNER JOIN jghstat07 j ON f.id = j.fall_id
            INNER JOIN code c ON j.hda = c.id
WHERE f.bgy <= {jahr} and (f.zday >= {jahr} or f.zday = 0) and 
      j.ey IS NULL and c.name = 'ja' and j.jahr = {jahr}
GROUP BY mygroup
""".format(jahr=jahr)
    res = getDBHandle().query(sql, dictionary=True)
    get_count(res, counters, sum_BS_Berichtsjahr_andauernd='ja')

    # BS fehlt

    sql = """
SELECT count(f.id) as mycount, 'fehlt' as mygroup
FROM fall f LEFT OUTER JOIN jghstat07 j ON f.id = j.fall_id
WHERE f.bgy <= {jahr} and (f.zday >= {jahr} or f.zday = 0) and 
      j.id IS NULL
GROUP BY mygroup
""".format(jahr=jahr)
    res = getDBHandle().query(sql, dictionary=True)
    get_count(res, counters, sum_BS_fehlt='fehlt')

    # BS sonstige

    sql = """
SELECT count(f.id) as mycount, IF(f.zday > 0, 'mit_zda', 'ohne_zda') as mygroup
FROM fall f INNER JOIN jghstat07 j ON f.id = j.fall_id
            INNER JOIN code c ON j.hda = c.id
WHERE f.bgy <= {jahr} and (f.zday >= {jahr} or f.zday = 0) and 
      ((j.ey IS NOT NULL and j.ey != {jahr}) OR
      (j.ey IS NULL and j.jahr != {jahr}))
GROUP BY mygroup
""".format(jahr=jahr)
    res = getDBHandle().query(sql, dictionary=True)
    get_count(res, counters, sum_BS_sonstige_zda='mit_zda',sum_BS_sonstige_ohne_zda='ohne_zda')
    counters.sum_BS_sonstige = counters.sum_BS_sonstige_zda + counters.sum_BS_sonstige_ohne_zda

    # assert (
    #     counters.sum_BS_Berichtsjahr_beendet +
    #     counters.sum_BS_Berichtsjahr_andauernd +
    #     counters.sum_BS_fehlt +
    #     counters.sum_BS_sonstige
    #     == 
    #     counters.sum_faelle
    #     )
    # print
    # print 'Berichtsjahr: ', berichtsjahr
    # print '======================'
    # print
    # for k,v in counters.__dict__.items():
    #     print k,v
    return counters


def jghexport(jahr, andauernd):
    """Erzeugt den Datensatz fr die Jugendhilfestatistik.

    Es werden zwei Strings zurckgegeben, der eigentliche Datensatz
    und ein Kontrolldatensatz mit Zeilenumbrchen und vorangesteller
    Fallnummer und Mitarbeiterkennung.
    """
    assert jahr == 2022
    jgh_laufende_nummer_setzen()

    get_datensatz = get_datensatz_ab_2022
    jghl_andauernd = Jugendhilfestatistik2007List(where = 'ey is NULL and jahr = %s' % jahr, order = 'lnr')

    where = 'ey=%s' % jahr
    where_fall = " and fall.zday > 0"
    where_kein_fall = " and fall_id IS NULL"
    join = [('fall', 'jghstat07.fall_id=fall.id')]
    jghl_abgeschlossen = (Jugendhilfestatistik2007List(where=where+where_fall, join=join) +
                          # wg des Join sind Statistiken ohne Fall nicht exportiert worden!
                          # Spielt aber praktisch keine Rolle, weil zum Zeitpunkt des Exports
                          # normalerweise die Flle nicht gelscht sind. Es knnte aber
                          # Einzelflle geben, wenn jemand ausdrcklich die Lschung verlangt.
                          #Jugendhilfestatistik2007List(where=where+where_kein_fall, join=join))
                          Jugendhilfestatistik2007List(where=where+where_kein_fall))
    # Hier geht es um mehrfache Hilfen fr einen einzelnen Klienten im Jahr.
    # Daher mssen sowohl abgeschlossene als auch andauernde Flle bercksichtigt werden.
    annotieren_mit_extras_ab_2022(jghl_abgeschlossen + jghl_andauernd)
    if andauernd:
        jghl = jghl_andauernd
    else:
        jghl = jghl_abgeschlossen
    jghl.sort('lnr')

    daten_saetze = []
    log_daten_saetze = []
    log_header = """Erzeugen der Datei mit den Datenstzen fr die Jugendhilfestatistik fr %s
%s
Erstellt am: %s
Datei: %s
Anzahl der Datenstze: %s

Datenstze (vorangestellt zustzlich Fallnummer und Mitarbeiterkennung):

""" % (jahr,
       andauernd and "(andauernde Flle)" or '',
       #time.strftime("%c", time.localtime(time.time())),
       today(),
       get_export_datei_name(jahr, False, andauernd),
       len(jghl))
    
    for record in jghl:
        daten_satz, log_daten_satz = get_datensatz(record)
        # Test neue Klasse mit Datensatzgenerierung
        daten_saetze.append(daten_satz)
        log_daten_saetze.append(log_daten_satz)
    return ''.join(daten_saetze), log_header + ''.join(log_daten_saetze)

def get_export_datei_name(jahr, log, andauernd):
    log = log and '_log' or ''
    t = today()
    if andauernd:
        date_and_type = "_am_%04d-%02d-%02d_andauernd" % (t.year, t.month, t.day)
    else:
        date_and_type = "_am_%04d-%02d-%02d_abgeschlossen" % (t.year, t.month, t.day)
    name = "jgh_%s%s%s.txt" % (jahr, date_and_type, log)
    return name

def annotieren_mit_extras_ab_2022(jghl):
    """
    Die fr die Bundesstatistik ab 2022 neuerdings erforderlichen
    Spalten Kennnummer (21-40), mehrfache Hilfen (41) und laufende Nummer (42-43)
    on the fly berechnen und als extra_*-Attribute in das jgh-Objekt einfgen.

    jghl: Liste aller abzugebenden Statistiken fr das Jahr,
    abgeschlossen und andauernd. Das ist erforderlich, da sonst
    mehrfache Hilfen im selben Jahr, bestehend aus ein- oder mehreren
    abgeschlossenen und einer andauernden, nicht korrekt gezhlt werden knnten.
    """
    jghl.sort('bgy', 'bgm')
    klienten = {} # id --> count
    for jgh in jghl:
        try:
            akte_id = jgh['fall__akte_id']
        except:
            # Kann passieren, wenn der zugehrige Fall gelscht wurde
            akte_id = None
        if akte_id:
            count = klienten.get(akte_id, 0)
            count += 1
            klienten[akte_id] = count
            extra_kennnummer = "%04d%s" % (jgh['jahr'], akte_id)
            extra_mehrere_hilfen = '1' if count > 1 else '2'
            extra_hilfen_lnr = ("%02d" % count) if count > 1 else None # wird durch substitution behandelt
        else:
            count = 1
            # kein Fall, evt. schon gelscht.
            # Mehrfache Hilfen knnen in diesem Fall nicht festgestellt werden.
            # Kennnummer bestehend aus jahr, '00', jgh_id
            # Wegen eingeschobener '00' garantierte keine Verwechslung
            # mit akte_id
            extra_kennnummer = "%04d00%s" % (jgh['jahr'], jgh['id'])
            extra_mehrere_hilfen = '2'
            extra_hilfen_lnr = None
        jgh['extra_kennnummer'] = extra_kennnummer
        jgh['extra_mehrere_hilfen'] = extra_mehrere_hilfen
        jgh['extra_hilfen_lnr'] = extra_hilfen_lnr
        # print 'Extra: (akte_id=%s, count=%s)' % (akte_id, count), jgh['extra_kennnummer'], jgh['extra_mehrere_hilfen'], jgh['extra_hilfen_lnr']
        

def get_datensatz_ab_2022(record):
    """Erzeugt einen Jugendhilfestatistikdatensatz fr einen Fall

    Zurckgegeben wird der eigentliche Datensatz sowie ein Kontrolldatensatz.
    """
    # Falls die Daten aus einer vor 2022 erstellten Statistik stammen
    if record['inobh42_22'] is None:
        if record['inobh42__code'] == '1':
            code_id = cc('inobh42_22', '1')
        else:
            code_id = cc('inobh42_22', '4')
        record.update({'inobh42_22': code_id})
    return JGHDatensatz_2022(record).get_datensatz()

def pp_datensatz(datensatz):
    """Nur zum testen. Statistikdatensatz so ausgeben, dass man den Wert
    fr jede Spalte des Formats leicht sehen und berprfen kann.
    """
    assert datensatz[-1] == '\n'
    assert datensatz[-2] == '\r'
    datensatz = datensatz[:-2] + 'rn' 
    size = len(datensatz)
    rows = 20
    columns = size / rows + 1
    def row(x):
        s = ''
        for i in range(columns):
            # python index in den string (startet mit 0)
            pindex = i*rows + x
            # Datensatzspalte gem Spezifikation (startet mit 1)
            jindex = pindex + 1
            if pindex < size:
                value = datensatz[pindex]
                s += '%03d %s  ' % (jindex, value)
        return s
    for i in range(rows):
        print row(i)
        
class JGHDatensatz_2022(object):
    """Aus einer Jugendhilfestatistik2007()-Instanz einen Datensatz 
    fr die statistischen Landesmter generieren.

    Ersetzt die Funktion get_datensatz_ab_2017().
    Liefert mit der Methode get_datensatz_ab_2017() identische Ergebnisse,
    ist aber auf Dauer besser zu pflegen, da alle Informationen ber den Datensatz in 
    der Tabelle datensatz_info konzentriert sind.
    Nur fr die neueste Datensatzdefinition ab 2017.
    Name und wireb_nr aus ebkus/wir.eb/Anlage Dateiformat Statistikdaten 2019-02-14.pdf
    """
    # name und wireb_nr spielt fr den traditionalle Export der Jugendhilfestatistik
    # keine Rolle.
    # name, wireb_nr, von, bis, field, format, substitution, value
    datensatz_info = (
        ('BA', None, 1, 1, None, None, None, 'A'),
        ('Land', None, 2, 3, 'land__code', '%02d', None, None),
        ('Kreis', None, 4, 6, 'kr__code', '%03d', None, None),
        ('Gemeinde', None, 7, 9, 'gemeinde', None, None, None),
        ('Einrichtungsnummer', None, 10, 15, 'einrnr__code', '%06d', None, None),
        ('LaufendeNummer', 1, 16, 20, 'lnr', '%05d', None, None),
        ('Kennnummer', None, 21, 40, 'extra_kennnummer', '%-20s', None, None),
        ('MehrereHilfen', None, 41, 41, 'extra_mehrere_hilfen', None, None, None),
        ('LaufendeNummerEinzelhilfe', None, 42, 43, 'extra_hilfen_lnr', '%02d', {None: '  '}, None),
        ('AGSWohnortdesBeratenen', 2, 44, 51, 'ags', '%8s', {None: ' '*8}, None),
        ('PLZWohnortdesBeratenen', 3, 52, 56, 'plz', '%5s', {None: ' '*5}, None),
        ('WohnortdesBeratenen', 4, 57, 96, 'ort', '%-40s', {None: ' '*40}, None),
        ('BeginnMonatHilfe', 5, 97, 98, 'bgm', '%02d', None, None),
        ('BeginnJahrHilfe', 6, 99, 102, 'bgy', '%04d', None, None),
        ('UebernahmeVonAnderemJugendamt', 7, 103, 103, 'zustw', '%1s', None, None),
        ('Gefaehrdungseinschaetzung', 8, 104, 104, 'gef8a__code', None, None, None),
        ('Schutzmassnahme', 9, 105, 105, 'inobh42_22__code', None, None, None),
        ('ArtHilfe', 10, 106, 107, 'hilf_art__code', None, None, None),
        ('OrtDurchfuehrung', 11, 108, 109, 'hilf_ort__code', None, None, None),
        ('TraegerEinrichtung', 12, 110, 111, 'traeger__code', None, None, None),
        ('FamilienOrientierteHilfe', None, 112, 112, None, None, None, '2'), # E1.1 Nein trifft immer zu bei uns
        ('Geschlecht', 13, 113, 113, 'gs__code', None, None, None),
        ('GeburtMonat', 14, 114, 115, 'gem', '%02d', None, None),
        ('GeburtJahr', 15, 116, 119, 'gey', '%04d', None, None),
        ('E2E3Leer', None, 120, 191, None, None, None, ' '*72),
        ('AufentOrtVorHilfe', 17, 192, 193, 'aort_vor__code', None, None, None),
        ('SituationHerkunft', 18, 194, 194, 'sit_fam__code', None, None, None),
        ('AuslaendHerkunft', 19, 195, 195, 'ausl_her__code', None, {'0': ' '}, None),
        ('SpracheDeutsch', 20, 196, 196, 'vor_dt__code', None, {'0': ' '}, None),
        ('SozialSicherung', 21, 197, 197, 'wirt_sit__code', None, {'0': ' '}, None),
        ('HilfeAusserhalbElternhaus', None, 198, 198, None, None, None, '2'), # G1 Nein trifft immer zu bei uns
        ('AktuellBesuchteAusbildungsstaette', None, 199, 200, None, None, None, ' '*2),
        ('Kontaktanregung', 22, 201, 201, 'aip__code', None, None, None),
        ('EntzugSorge', 23, 202, 202, 'ees__code', None, None, None),
        ('GerichtlAnordnung', 24, 203, 203, 'va52__code', None, None, None),
        ('RichtGenehm', 25, 204, 204, 'rgu__code', None, None, None),
        ('AndauerHilfeJahresende', 26, 205, 205, 'hda__code', None, None, None),
        ('ZahlKontakte', 27, 206, 208, 'nbkakt', '%03d', {None: '   '}, None),
        ('J2Leer', None, 209, 212, None, None, None, ' '*4),
        ('HauptgrundHilfegewaehrung', 30, 213, 214, 'gr1__code', None, None, None),
        ('ZweiterGrund', 31, 215, 216, 'gr2__code', None, {None: '  '}, None),
        ('DritterGrund', 32, 217, 218, 'gr3__code', None, {None: '  '}, None),
        ('EndeMonatHilfe', 33, 219, 220, 'em', '%02d', {None: '  '}, None),
        ('EndeJahrHilfe', 34, 221, 224, 'ey', '%04d', {None: '    '}, None),
        ('ZahlKontakteEnde', 35, 225, 227, 'nbkges', '%03d', {None: '   '}, None),
        ('LetzterKontakt', 36, 228, 228, 'lbk6m__code', None, {None: ' '}, None),
        ('M2Leer', None, 229, 232, None, None, None, ' '*4),
        ('GrundEndeHilfe', 39, 233, 234, 'grende__code', None, {None: '  '}, None),
        ('AnschlAufenthalt', 40, 235, 236, 'aort_nac__code', None, {None: '  '}, None),
        ('NachfolgendeHilfe', 41, 237, 237, 'unh__code', None, {None: ' '}, None),
        ('Datensatzende', None, 238, 239, None, None, None, '\r\n'),
        )

    def __init__(self, jgh):
        self.jgh = jgh
        gs = config.JGH_GEMEINDESCHLUESSEL
        if gs == 'blank':
            gs = '   '
        elif not gs:
            gs = '000'
        ags = plz = ort = ''
        ags_plz_ort = get_ags_plz_ort_if_wohnort_ausserhalb(jgh)
        if ags_plz_ort:
            ags, plz, ort = ags_plz_ort
            if ags:
                plz = ort = '' # plz, ort nur wenn Gemeindeschlssel unbekannt ist.
        self.ags_plz_ort_gs = dict(ags=ags, plz=plz, ort=ort, gemeinde=gs)

    def get_value(self, field, format, substitution, value):
        # Konstanter Wert, steht schon in datensatz_info 
        if value is not None:
            return value
        assert field is not None
        try:
            # Einige Werte in __init__() berechnet
            value = self.ags_plz_ort_gs[field]
        except KeyError:
            # Die groe Masse direkt aus der jgh-Instanz
            value = self.jgh[field]
        if substitution:
            # Falls es ein Substitution gibt, die nehmen
            res = substitution.get(value)
            if res is not None:
                return res
        # Wir mssen jetzt einen Wert haben
        assert value is not None
        if format:
            # Formatieren, falls format definiert ist
            if format.endswith('d'):
                # print field, format, substitution, value
                value = int(value)
            return format % value
        return value

    def get_datensatz(self):
        """Liefert exakt dasselbe Ergebnis wie die alte Funktion:
        datensatz, log_datensatz
        """
        last_bis = 0 # Intervalle prfen
        res = []
        for name, wireb_nr, von, bis, field, format, substitution, value in self.datensatz_info:
            assert von == last_bis + 1
            last_bis = bis
            data = self.get_value(field, format, substitution, value)
            assert isinstance(data, str)
            assert len(data) == (bis - von + 1)
            res.append(data)
        datensatz = ''.join(res)
        assert len(datensatz) == 239
        # print self.jgh['fall_fn'], self.jgh['fall__akte_id']
        # pp_datensatz(datensatz)
        if datensatz[204] == '1': # Hilfe dauert an
            assert datensatz[218:237] == ' '*19
        else:
            # print datensatz
            # print '>%s<' % datensatz[205:212]
            assert datensatz[205:212] == ' '*7
        log_datensatz = "%-14s%-10s%s" % (self.jgh['fall_fn'], self.jgh['mit_id__ben'], datensatz)
        return datensatz, log_datensatz
    
        
