# coding: latin-1

# Die http-Tests funktionier nur, wenn das Pythonpaket requests in der Version 2.2.1 oder 2.3.0 installiert ist.
# Hhere Versionen funktionieren nicht, ich habe nicht verstanden warum nicht.
# Nach dem logout, das ein Redirect mit location: login generiert, antwortet requests > 2.3.0 mit pwchange
# anstatt mit login. Das fhr auf eine Seite 'Zugriff verweigert'.

"""
TestDaten:
- bietet eine Funktion fr jede API-Funktion in ebupb
- 
"""


"""
Test, Demo und Schulungsdatenbanken erzeugen

Es gibt eine Reihe von mit Namen versehenen Profilen, die bei der Generierung
initialer Datenbanken verwendet werden knnen.
Es sollte auch mglich sein, als Admin einer 
demo-Instanz die Datenbank zu initialisieren. 

Varianten aufgrund der Konfiguration:

Beratungskontakte: nein, ja, bs
fallunabhaengige_aktivitaeten_bs: nein, ja
strassenkatalog: nein, ja
strassenkatalog_vollstaendig: nein, ja
strassensuche: ort, ortsteil, samtgemeinde, bezirk

Gengen drei Varianten?
- braunschweig: 
  beratungskontakte_bs: ja
  fallunabhaengige_aktivitaeten_bs: ja
  strassenkatalog: ja
  strassenkatalog_vollstaendig: nein
  strassensuche: ort, ortsteil, samtgemeinde, bezirk

- berlin:
  beratungskontakte: ja
  fallunabhaengige_aktivitaeten_bs: nein
  strassenkatalog: ja
  strassenkatalog_vollstaendig: ja
  strassensuche: bezirk

- minimal ohne beratungskontakten:
  beratungskontakte: nein
  fallunabhaengige_aktivitaeten_bs: nein
  strassenkatalog: nein
  strassenkatalog_vollstaendig: nein
  strassensuche: nein


Zeit:
- ebapi.today() liefert aktuelles Datum oder ein benutzerdefiniertes wenn config.TODAY einen Wert hat, zB 2012-12-24
"""

import sys, os, time, sha, re
from ebkus.app.ebapi import cc, cn, getNewFallnummer, Date, today, str2date, getDate, setDate, \
    Time, setTime, getTime, \
    Kategorie, Code, Mitarbeiter, MitarbeiterList, Akte, AkteList, Fall, FallList, Leistung, \
    Beratungskontakt, FeldList, Tabelle, Feld, \
    Zustaendigkeit, Bezugsperson, Einrichtungskontakt, Anmeldung, CodeList, \
    StrassenkatalogNeu, StrassenkatalogNeuList, Fachstatistik, Jugendhilfestatistik, Jugendhilfestatistik2007, \
    Altdaten, \
    calc_age, bcode
from ebkus.db.dbapp import DBAppError
from ebkus.app.ebapih import  get_codes, get_all_codes
from ebkus.app.ebupd import akteeinf, fseinf, jgh07einf, miteinf, codeeinf, \
    leisteinf, zdaeinf, waufneinf, perseinf, einreinf, anmeinf
from ebkus.html.strkat import split_hausnummer
from ebkus.html.akte_share import akte_share
from random import choice, randrange, randint, sample, random, seed

import logging
def log(s):
    logging.info(s)
    print s
def list_for_class(klass):
    return globals()[klass.__name__ + 'List']

profile = {
    # name, # dict mit Parametern
    'minimal': {
         'beratungskontakte_bs': False,
         'beratungskontakte': False,
         'fallunabhaengige_aktivitaeten_bs': False,
         'strassenkatalog': False,
         'strassenkatalog_vollstaendig': False,
         #'strassensuche':  "ort, ortsteil, samtgemeinde", # entsprechend werden Eintrge in den Strassenkatalog gemacht
         'strassensuche': None,
         #'plraum': True,
         'anmeldungsdaten_obligatorisch': False,
         'wiederaufnahmefrist': 3,
         }
}

namen = {
    'strassen': ('Teichweg', 'Mllerstr.', 'Am Rott', 'Karl-Marx-Str.',
                'Hinterm Markt', 'Rosenweg'),
    'orte': ('Unterhausen', 'Gro-Lehnau', 'Klein-Magrau'),
    'vornamen': ('Tom', 'gr', 'Frieda', 'Magda', 'Hugo', 'Peter', ),
    'nachnamen': ('Ha', 'hlbrecht', 'Wderich', 'Schmidt', 'Mller', 'Dsentrieb'),
}

class Form(dict):
    """
    Die Werte aus kw haben Prioritt. Bei FK kann entweder die ID stehen,
    oder ein String, der genau ein Objekt kennzeichnet.
    Danach kommen Werte aus der dict, die mit dem values Parameter bergeben
    wird.
    Erst dann werden zufllige Werte erzeugt, eingeschrnkt durch:
    - mini/maxi bei date und integer
    - off/keine Angaben bei code
    - stz, benr, stat bei id

    Form(test_daten, kw)
    
    Jedes Element von Feldnamen ist entweder der Name eines Feldes in der entsprechenden 
    Klasse, oder ein Tupel (feldname, aktueller Name). Der aktuelle Name wird fr das Feld 
    in dieser Form verwendet.

    id(klass, feldnamen, values={}, stz=None, benr=None newid=False
    code(klass, feldnamen, values=fn->val, off=False, keine_angaben=False)
    str(klass, feldnamen,  values=fn->val, format=fn->formatstr))
    adresse(klass, feldnamen, values)
    integer(klass, feldnamen, values=fn->val, mini=int, maxi=int
    date(klass, feldnamen, values=fn->val, mini=Date(), maxi=Date())
    
    """
    def __init__(self, test_daten, **kw):
        self.td = test_daten
        self['file'] = kw.get('file')
        self.kw = kw
        #print "FORM kw", self.kw
    def _get_code_id(self, klass, fname, value):
        """fname: Feldname fr Feld in klass
           value: Entweder id, dann sofort zurckgeben
                  oder code, dann 
                             - in klass fr fname kat_code suchen
                             - id raussuchen und zurckgeben
                  
        """
        if isinstance(value, (int, long)):
            return value
        tab_id = Tabelle(tabelle=klass.table)['id']
        feld = Feld(feld=fname, tab_id=tab_id)
        kat_code = feld['kat_code']
        return self._get_id_for_name(value, Code, kat_code)
    def _get_values(self, feldnamen, **kw):
        """
        Liefert:
        value_dict: feldname --> Wert
           Enthlt nur Werte die in self.kw, value, values
           gefunden wurden.
           Wenn der Wert None gefunden wurde, bedeutet das, 
           dass der Parameter aus der form weggelassen werden sollte.
        map_dict: fname --> alias
           alias ist mit fname identisch auer bei feldnamen gab es
           fr fname ein Tupel (fname, alias)
        """
        first_value = kw.get('value')
        values = kw.get('values', {})
        value_dict = {} # fname --> Wert
        map_dict = {}   # fname --> fname oder alias
        uuid = '432518891048771939848590110'
        for i, fname in enumerate(feldnamen):
            value = uuid
            if isinstance(fname, tuple):
                fname, alias = fname
            else:
                alias = fname
            if alias in self.kw:
                value = self.kw[alias]
            elif first_value and i == 0:
                value = first_value
            elif alias in values:
                value = values[alias]
            if value != uuid: # Falls noch auf uuid, wurde kein Werte gefunden, auch nicht None
                value_dict[fname] = value
            #print '_get_values', i, fname, alias, value
            map_dict[fname] = alias
        return value_dict, map_dict
    def id(self, klass, *feldnamen, **kw):
        newid = kw.get('newid', False)
        assert len(feldnamen) == 1
        value_dict, map_dict = self._get_values(feldnamen, **kw)
        fname = map_dict.keys()[0]
        #print 'ID value_dict', value_dict, map_dict, fname
        if fname in value_dict:
            val = value_dict[fname]
            if val is None:
                return # Parameter weglassen!!
            val = self._get_id_for_name(val, klass)
        elif newid:
            val = klass().getNewId()
        else:
            where = []
            for attr in ('stz', 'benr', 'stat'):
                value = kw.get(attr)
                if value is not None:
                    where.append('{fname} = {id}'.format(
                            fname=attr, 
                            id=self._get_code_id(klass, attr, value)))
            res = list_for_class(klass)(where=' AND '.join(where))
            val = choice(res)['id']
        self[map_dict[fname]] = val

    def id_multiple(self, klass, *feldnamen, **kw):
        """Formattribut wird mit einer Liste von ids belegt. """
        newid = kw.get('newid', False)
        how_many = kw.get('how_many', 2)
        assert not newid
        assert len(feldnamen) == 1
        value_dict, map_dict = self._get_values(feldnamen, **kw)
        fname = map_dict.keys()[0]
        #print 'ID value_dict', value_dict, map_dict, fname
        if fname in value_dict:
            val = value_dict[fname]
            if val is None:
                return # Parameter weglassen!!
            if not isinstance(val, (tuple, list)):
                val = [val]
            val = [self._get_id_for_name(v, klass) for v in val]
        else:
            where = []
            for attr in ('stz', 'benr', 'stat'):
                value = kw.get(attr)
                if value is not None:
                    where.append('{fname} = {id}'.format(
                            fname=attr, 
                            id=self._get_code_id(klass, attr, value)))
            res = list_for_class(klass)(where=' AND '.join(where))
            val = [x['id'] for x in sample(res, min(how_many, len(res)))]
        self[map_dict[fname]] = val
        
    def str(self, klass, *feldnamen, **kw):
        value_dict, map_dict = self._get_values(feldnamen, **kw)
        format = kw.get('format', {})
        id_val = self.get(kw.get('id_key'))
        for fname in map_dict:
            if fname in value_dict:
                val = value_dict[fname]
                if val is None:
                    continue # Feld weglassen
            else:
                if fname in format:
                    fstr = format[fname]
                    val = fstr.format(int1=randrange(0,10),
                                      int2=randrange(10,100),
                                      int3=randrange(100,1000),
                                      int4=randrange(1000,10000),
                                      **self)
                else:
                    val = "{fname}_{id}".format(id=id_val, fname=fname)
            self[map_dict[fname]] = val

    def code(self, klass, *feldnamen, **kw):
        off = kw.get('off', False)
        keine_angaben = kw.get('keine_angaben', False)
        value_dict, map_dict = self._get_values(feldnamen, **kw)
        tab_id = Tabelle(tabelle=klass.table)['id']
        for fname in map_dict:
            if fname in value_dict:
                val = value_dict[fname]
                if val is None:
                    continue # Feld weglassen
                val = self._get_code_id(klass, fname, val)
            else:
                val = self._get_random_code(klass, fname, off=off, keine_angaben=keine_angaben)
            self[map_dict[fname]] = val
    def date(self, klass, *feldnamen, **kw):
        mini = kw.get('mini')
        maxi = kw.get('maxi')
        value_dict, map_dict = self._get_values(feldnamen, **kw)
        if mini is None:
            mini = self.td.von_jahr
        if maxi is None:
            maxi = self.td.bis_jahr
        for fname in map_dict:
            noday = False
            if fname + 'y' in klass.fields:
                if not fname + 'd' in klass.fields:
                    noday = True
            if fname in value_dict:
                val = value_dict[fname]
                if val is None:
                    continue # Feld weglassen
                if isinstance(val, basestring):
                    val = str2date(val)
            else:
                val = self.td.choose_date(mini=mini, maxi=maxi)
            assert isinstance(val, Date)
            alias = map_dict[fname] 
            setDate(self, alias, val)
            # self[alias + 'y'] = val.year
            # self[alias + 'm'] = val.month
            # if not noday:
            #     self[alias + 'd'] = val.day
    def time(self, klass, *feldnamen, **kw):
        value_dict, map_dict = self._get_values(feldnamen, **kw)
        #print 'TIME', value_dict, map_dict
        for fname in map_dict:
            if fname in value_dict:
                val = value_dict[fname]
                if val is None:
                    continue # Feld weglassen
                if isinstance(val, basestring):
                    hour, minute = val.split(':')
                    val = Time(hour=int(hour), minute=int(minute))
            else:
                val = Time(hour=randrange(0,24), minute=randrange(0,60))
            assert isinstance(val, Time)
            alias = map_dict[fname] 
            setTime(self, alias, val)

    def integer(self, klass, *feldnamen, **kw):
        mini = kw.get('mini', 0)
        maxi = kw.get('maxi', 100)
        value_dict, map_dict = self._get_values(feldnamen, **kw)
        for fname in map_dict:
            if fname in value_dict:
                val = value_dict[fname]
                if val is None:
                    continue # Feld weglassen
            else:
                val = randrange(mini, maxi)
            self[map_dict[fname]] = val

    def adresse(self, klass, *feldnamen, **kw):
        value_dict, map_dict = self._get_values(feldnamen, **kw)
        adresse = self._get_adresse(strid=value_dict.get('strid'))
        for fname in map_dict:
            if fname in value_dict:
                val = value_dict[fname]
                if val is None:
                    continue # Feld weglassen
            else:
                val = adresse.get(fname)
            if val is not None:
                self[map_dict[fname]] = val

    def _get_adresse(self, strid=None):
        obj = {}
        if self.td.config.STRASSENKATALOG:
            obj['lage'] = cc('lage', '0') 
            obj['strkat_on'] = 1
            if strid:
                st = StrassenkatalogNeu(strid)
            else:
                st = choice(self.td.strkat)
            #print 'ST', st
            obj['strid'] = str(st['id'])
            obj['str'] = st['name']
            obj['ort'] = st['ort']
            von, bis = st['von'], st['bis']
            if von and bis:
                vnummer =  split_hausnummer(von)[0]
                bnummer =  split_hausnummer(bis)[0]
                if vnummer == bnummer:
                    obj['hsnr'] = von
                else:
                    assert vnummer < bnummer
                    nr = randrange(vnummer, bnummer+1, 2)
                    if nr == vnummer:
                        nr = von
                    elif nr == bnummer:
                        nr = bis
                    obj['hsnr'] = str(nr)
            else:
                assert von == bis == None
                obj['hsnr'] = str(randrange(1, 200))
            obj['plz'] = st['plz']
            #print 'OBJ', obj
            #print 'STRASSENKATALOG:', self.config.STRASSENKATALOG
        else:
            obj['lage'] = cc('lage', '1') 
            obj['str'] = choice(self.td.strassen)
            obj['hsnr'] = str(randrange(1, 200))
            obj['plz'] = "%05d" % randrange(16000, 99999)
            #obj['plraum'] = "%08d" % randrange(60, 61+int(self.n_akten**.35))
            obj['plraum'] = "%08d" % randrange(60, 61+int(50**.35))
            obj['ort'] = choice(self.td.orte)
        return obj


    def _get_random_code(self, klass, fname, off=False, keine_angaben=False, how_many=2):
        """off True: einschlielich deaktivierte Codes
           keine_angaben True: einschlielich Code '999'
           how_many: Anzahl der codes bei multi Code.
        """
        tab_id = Tabelle(tabelle=klass.table)['id']
        feld = Feld(feld=fname, tab_id=tab_id)
        kat_code = feld['kat_code']
        verwtyp = Code(feld['verwtyp'])['code']
        assert verwtyp in ('k', 'm'), "Klasse: {klass} Feld: {fname} verwtyp: {verwtyp}".format(**locals())
        if off:
            codes = get_all_codes(kat_code)
        else:
            codes = get_codes(kat_code)
        if not keine_angaben:
            codes = [x for x in codes if x['code'] != '999']
        #print klass, fname, verwtyp, codes
        if verwtyp == 'k':
            return choice(codes)['id']
        elif  verwtyp == 'm':
            return [x['id'] for x in sample(codes, min(how_many, len(codes)))]


    def _get_id_for_name(self, name, klass, kat_code=None):
        """Einige Objekte kann man ber einen Namen identifizieren.
        """
        if isinstance(name, (int, long)):
            # ist schon id
            return name
        table = klass.table
        table2name = {
            'akte': ('vn', 'na'),
            'bezugsperson': ('vn', 'na'),
            'mitarbeiter': ('ben',),
            'fall': ('fn',),
            'einrichtung': ('na',),
            'dokument': ('fname',  ),
            'gruppe': ('name', 'gn'),
            'kategorie': ('code', 'name'),
            # code kriegt Sonderbehandlung
            }
        res = None
        if table in table2name:
            for fname in table2name[table]:
                try:
                    #print 'GET_ID_FOR_NAME', klass, type(klass), fname, name, type(name)
                    obj = klass(**{fname: name})
                    res = obj['id']
                except DBAppError:
                    pass
        elif table == 'code':
            res = Code(code=name, kat_code=kat_code)['id']
        else:
            raise Exception("_get_id_for_name() nicht verfgbar ")
        #print '_GET_ID_FOR_NAME', name, klass, kat_code, res
        return res

class TestDaten(object):
    """Eine Instanz dieser Klasse generiert eine EBKuS-Datenbank mit knstlichen Daten.

    Geeignet zum Generierien von Test-, Demo- und Schulungsinstanzen.

    Vor dem Erzeugen der Daten werden evt. vorhandene Daten vollstndig gelscht.
    Man kann also mit dieser Klasse keine Daten 'hinzugenerieren'.

    Identische Parameter sollte immer identische Datenbanken erzeugen (mit Ausnahme
    des in vielen Tabellen enthaltenen Feldes 'zeit', Zeitstempel fr die letzte nderung), 
    wenn folgende Bedingungen erfllt sind.
    - today explizit angegeben
    - random_data auf False gesetzt



    Alle Methoden, die Testdaten fr ebupd erzeugen, sollten Parameter wie folgt nehmen:
    - Fremdschlssel zu Entitten werden als Integer Id bergeben (akte_id, etc.)
    - Codes knnen als Feldname=Code bergeben werden, falls nicht vorhanden, zufllig
    - Datum kann als yyyy-mm-dd - String bergeben werden, sonst zuflliges Datum
    - Primitive Werte knnen direkt bergeben werden.
    
    """
    strassen = ('Teichweg', 'Mllerstr.', 'Am Rott', 'Karl-Marx-Str.',
                'Hinterm Markt', 'Rosenweg')
    orte = ('Unterhausen', 'Gro-Lehnau', 'Klein-Magrau')
    vornamen = ('Tom', 'gr', 'Frieda', 'Magda', 'Hugo', 'Peter', )
    nachnamen = ('Ha', 'hlbrecht', 'Wderich', 'Schmidt', 'Mller', 'Dsentrieb')
    laender = (('Stelle A', 'Niedersachsen'), ('Stelle B', 'Bayern')) # name der Stelle, name des Landes
    kreise = (('Stelle A', '920', 'Margenstadt'), ('Stelle B', '921', 'Lehnberg')) # name der stelle, code, name
    # Die Zuordnung von Einrichtungsnummer zur Stelle erfolgt lediglich ber
    # den Eintrag des Stellennames in das Dokumentationsfeld der Einrichtungsnummer.
    einrichtungsnummern = (('Stelle A', '100100'), ('Stelle B', '200200')) # name der stelle, einrnr
    stellen = (('A', 'Stelle A'), ('B', 'Stelle B')) # code, name
    def __init__(self,
                 instance_name="test", # nur fr logging
                 profil='minimal',
                 seed=100,
                 von_jahr=None,
                 bis_jahr=None,
                 heute=None,
                 log=None,
                 open_database=True,
                 **kw
                 ):
        self.instance_name = instance_name
        # Instanzname muss mit 'test_', 'demo_' oder 'schulung_' anfangen
        sis = self.instance_name.startswith
        assert sis('test') or sis('demo') or sis('schulung'), 'Keine Testinstanz: {}'.format(self.instance_name)
        if seed:
            import random
            random.seed(seed)
        #print '********************** SEED ************************:', seed
        from ebkus.config import config
        if heute:
            config.TODAY = heute
        self.config = config
        #print 'TestDaten.config:', id(self.config)
        #print 'TESTDATEN: DBNAME', self.config.DATABASE_NAME
        if not bis_jahr:
            bis_jahr = today()
        if not von_jahr:
            von_jahr = bis_jahr.add_month(-24)
        self.bis_jahr = bis_jahr
        self.von_jahr = von_jahr
        assert self.bis_jahr.check() and not self.bis_jahr.is_zero()
        assert self.von_jahr.check() and not self.von_jahr.is_zero()
        assert self.von_jahr < self.bis_jahr
        self.log = log
        from ebkus.db.sql import opendb
        if open_database:
            opendb()
        ort = self.config.STRASSENKATALOG
        if ort:
            self.strkat = StrassenkatalogNeuList(where='')
            assert self.strkat, 'Strassenkatalog ist leer'
            #self.ort = ort.capitalize()
            #self.test_strassenkatalog(self.strkat)
    def test_strassenkatalog(self, strkat):
        # alle Straen/PLZ mit mehreren Eintrgen
        from collections import defaultdict
        dall = defaultdict(list)
        for s in strkat:
            dall[(s['ort'], s['plz'], s['name'])].append(s)
        dmulti = dict([(k,v) for k,v in dall.items() if len(v) > 1])
        dsingle = dict([(k,v) for k,v in dall.items() if len(v) == 1])
        print 'STRKAT single:', len(dsingle)
        print 'STRKAT multi:', len(dmulti)
        #for k, v in dsingle.items():
        n_disj = 0
        for k, v in dmulti.items():
            res = self.test_strkat_entry(k, v)
            if res:
                n_disj += 1
        print 'DISJOINT:', n_disj
        #sys.exit(0)
    def test_strkat_entry(self, k, strkat_list):
        #print k
        ort, plz, name = k
        # print name, plz

        from ebkus.html.strkat import split_hausnummer
        def geti(s):
            G = False # gerades Intervall und gu None
            U = False # ungerades Intervall und gu None
            von = s['von']
            bis = s['bis']
            gu =  s['gu']
            assert (von is None and bis is None and gu is None) or (von is not None and bis is not None)
            if von is None:
                return None
            vn, vb, vgu = split_hausnummer(von)
            bn, bb, bgu = split_hausnummer(bis)
            
            assert vgu in ('G', 'U') and bgu in ('G', 'U')
            G = vgu == 'G' and bgu == 'G'
            U = vgu == 'U' and bgu == 'U'
            return G, U, gu, von, bis 
        def disjoint(s1, s2):
            gu1 = s1['gu']
            gu2 = s2['gu']
            von1 = s1['von']
            von2 = s2['von']
            bis1 = s1['bis']
            bis2 = s2['bis']
            assert von1 <= bis1
            assert von2 <= bis2
            if bis1 < von2 or von1 > bis2:
                return True
            if gu1 is not None and gu2 is not None and gu1 != gu2:
                return True
            return False
        # for s in strkat_list:
        #     res = geti(s)
        #     if res:
        #         G, U, gu, von, bis = res
        #         #f G or U and gu is None:
        #         print ort, plz, name, gu, von, bis
        #     else:
        #         #print ort, plz, name, None
        #         pass
        has_disjoints = False
        for i,s in enumerate(strkat_list):
            for t in strkat_list[i+1:]:
                if not disjoint(s, t):
                    has_disjoints = True
                    print 'NOT DISJOINT:', s
                    print '            :', t
        return has_disjoints
        #print '----------------------'
        # if U and G:
        #     print 'FEHLER STRKAT: ', strkat_list
    def miteinf(self, **kw):
        #['id', 'vn', 'na', 'ben', 'anr', 'tl1', 'fax', 'mail', 'stat', 'benr', 'stz', 'zeit', 'pass']
        assert 'ben' in kw
        assert 'benr' in kw
        assert 'stz' in kw
        form = Form(self, **kw)
        form.id(Mitarbeiter, ('id', 'mitid'), newid=True)
        form.code(Mitarbeiter, 'stat', 'benr', 'stz')
        form.str(Mitarbeiter, 'ben', 'anr', 'tl1', 'fax',
                 format={'anr': 'Frau',
                         'tl1': '01{int2} {int4} {int4}',
                         'fax': '{int4} {int4} {int4}',
                         })
        form.str(Mitarbeiter, 'vn', 'na','mail', values={
                'vn': "{ben}_vn{mitid}".format(**form),
                'na': "{ben}_na{mitid}".format(**form),
                'mail': "{ben}@efb.org".format(**form),
                })
        return form


    def akteeinf(self, **kw):
        """erzeugt Daten fr eine Akteneinfhrung"""
        assert 'zubg' in kw
        #assert 'file' in kw
        #print 'FILE', kw['file']
        #print 'AKTEEINF', kw.get('anmeldung'), kw
        form = Form(self, **kw) # self, damit config etc zugnglich ist

        # Alles Felder aus der Klasse nehmen, die in feldlist stehen.
        # Feldname ersetzen gem replace
        # Zufallswerte nehmen, auer Werte sind in kw spezifiziert.
        form.id(Akte, ('id', 'akid'), newid=True) 
        form.code(Akte, 'gs', 'aufbew', 'fs', 'stzbg', 'stzak', 'qualij', 'bkm', 'bkv')

        form.str(Akte, 'vn', 'na', 'ber', 'tl1', 'tl2', 'mail', 'no', 'geschw', 
                 id_key='akid',
                 format={
                        'vn': 'Klient{akid}Vn',
                        'na': 'Klient{akid}Na',
                        'no': 'Aktennotiz{akid}',
                        'tl1': '01{int2} {int4} {int4}',
                        'tl2': '0{int3}/{int4} {int4}',
                        })
        form.adresse(Akte, 'str', 'hsnr', 'plz', 'plraum', 'lage', 'ort', 'strkat_on')
        form.date(Akte, 'gb', 
                  mini=self.von_jahr.add_month(-240),
                  maxi=self.bis_jahr.add_month(-24),
                  )
        # Fallbeginn
        form.date(Zustaendigkeit, ('bg', 'zubg'), 
                  mini=max(self.von_jahr,
                           getDate(form, 'gb')) # nicht vor Geburt :-)
                  )
        form.date(Leistung, ('bg', 'lebg'),
                  values={'lebg': getDate(form, 'zubg')},
                  )
        form.id(Mitarbeiter, ('id', 'zumitid'), stz=form['stzbg'], benr='bearb', stat='i')
        form.id(Mitarbeiter, ('id', 'lemitid'), 
                #value='test',
                )
        form.code(Leistung, ('stz', 'lestz'), 'le', values={
                'lestz': form['stzbg'],
                })
        if self.config.ANMELDUNGSDATEN_OBLIGATORISCH:
            anm_form = self.anmeinf(fallid=None)
            del anm_form['file']
            form.update(anm_form)

        # TODO
        # Falls zubg vor 2017 liegt, kein Geschlecht mit dem Wert 'ohne Angabe...'
        # if getDate(form, 'zubg').year < 2017 and form[]

        # TEST
        #print 'AKTEEINF FORM'
        #for k,v in form.items(): print "{:<20} {}".format(k,v)
        return form

    def anmeinf(self, **kw):
        form = Form(self, **kw)
        form.id(Anmeldung, ('id', 'anmid'), newid=True)
        assert 'fallid' in kw
        form.id(Fall, ('id', 'fallid'))
        form.str(Anmeldung, 'von', 'mtl', 'me', 'mg', 'anm_no', format={
                'von': "Gemeldet von: {anmid}",
                'mtl': "123456{anmid}",
                'me': "Empfohlen von: {anmid}",
                'mg': "Anmeldegrund: {anmid}",
                'anm_no':  "Notiz fr Anmeldung: {anmid}",
                })
        form.code(Anmeldung, 'zm', 'anmprobleme')
        return form

    def zdaeinf(self, **kw):
        form = Form(self, **kw)
        assert 'fallid' in kw
        assert 'zda' in kw
        fall_id = kw['fallid']
        fall = Fall(fall_id)
        form.id(Fall, ('id', 'fallid'))
        form.id(Mitarbeiter, ('id', 'aktuellzustid'), value=fall['zustaendig__id'])
        form.date(Fall, 'zda')
        return form

    def zdareinf(self, **kw):
        form = Form(self, **kw)
        assert 'fallid' in kw
        form.id(Fall, ('id', 'fallid'))
        return form

    def waufneinf(self, **kw):
        form = Form(self, **kw)
        assert 'akid' in kw
        assert 'zubg' in kw
        akte = Akte(kw['akid'])
        zubg = kw['zubg']
        letzter_fall = akte['letzter_fall']
        zdadatum = letzter_fall.getDate('zda')
        assert zdadatum != Date(0,0,0), "Wiederaufnahme eines offenen Falls"
        # print 'ZDADATUM', zdadatum
        # print 'WIEDERAUFNAHMEFRIST', self.config.WIEDERAUFNAHMEFRIST
        # print 'ZDADATUM + WIEDERAUFNAHMEFRIST:', zdadatum.add_month(int(self.config.WIEDERAUFNAHMEFRIST))
        # print 'ZUBG', zubg
        #assert zdadatum.add_month(int(self.config.WIEDERAUFNAHMEFRIST)) < zubg, "Wiederaufnahme vor der Wiederaufnahmefrist"
        # Rausgenommen, weil Fehler auftreten. Woran liegt das?
        #assert zubg >= zdadatum.add_month(int(self.config.WIEDERAUFNAHMEFRIST)), "Wiederaufnahme vor der Wiederaufnahmefrist"
        form.id(Akte, ('id', 'akid'))
        form.id(Fall, ('id', 'fallid'), newid=True)
        form.date(Akte, 'gb', value=akte['gb'])
        form.code(Akte, 'gs', 'aufbew', 'fs', 'stzbg', 'qualij', 'bkm', 'bkv', values={
                'gs': akte['gs'],
                'stzbg': akte['stzbg'],
                })
        form.adresse(Akte, 'str', 'hsnr', 'plz', 'plraum', 'lage', 'ort', 'strkat_on', values=akte)
        assert form['str'] == akte['str']
        form.date(Zustaendigkeit, ('bg', 'zubg'))
        form.id(Mitarbeiter, ('id', 'zumitid'), stz=form['stzbg'], benr='bearb')
        form.id(Mitarbeiter, ('id', 'lemitid'), stz=form['stzbg'], benr='bearb')
        form.date(Leistung, ('bg', 'lebg'),
                  values={'lebg': getDate(form, 'zubg')},
                  )
        form.code(Leistung, ('stz', 'lestz'), 'le', values={
                'lestz': form['stzbg'],
                })
        if self.config.ANMELDUNGSDATEN_OBLIGATORISCH:
            anm_form = self.anmeinf(fallid=None)
            del anm_form['file']
            form.update(anm_form)
        return form

    def bkonteinf(self, **kw):
        """ """
        assert 'bkfallid' in kw # knnen mehrere sein, muss mindestens 1 sein
        assert 'k' in kw
        fall = Fall(kw['bkfallid'][0])
        fall_id = fall['id']
        stz = fall['akte__stzbg']
        form = Form(self, **kw)
        form.code(Beratungskontakt, 'stz', value=stz)
        form.id(Beratungskontakt, ('id', 'bkontid'), newid=True)
        form.id(Fall, ('id', 'fallid'), value=fall_id)
        form.id(Mitarbeiter, ('id', 'bearbeiterid'), value=fall['zustaendig__mit__id'])
        form.id_multiple(Fall, ('id', 'bkfallid'))
        form.id_multiple(Mitarbeiter, ('id', 'mitid'), stz=stz, benr='bearb', stat='i')
        form.date(Beratungskontakt, 'k')
        if self.config.BERATUNGSKONTAKTE_BS:
            del form.kw['k'] # damit time nicht als in kw gegeben angenommen wird
            form.time(Beratungskontakt, 'k')
            form['fruehquart'] = '1'
            form.code(Beratungskontakt, 'art_bs', 'teilnehmer_bs', 'offenespr')
            form.integer(Beratungskontakt, 'dauer', mini=2, maxi=12)
            form['dauer'] *= 10 # nur in 10ner Schritten
            form.integer(Beratungskontakt, 'anzahl', mini=1, maxi=5)
        else:
            form.code(Beratungskontakt, 'art', ('dauer', 'dauer_kat'))
        if self.config.BERATUNGSKONTAKT_DOKUMENTATION:
            # wir simulieren kein erstgesprch, das wre aufwendig
            form.code(Beratungskontakt, 'erstgespraech', value=cc('ja_nein', '2'))
            form.str(Beratungskontakt, 'inhalt', format={
                'inhalt':  "Inhalt des Beratungskontakts: {bkontid}",
                })
            form.integer(Beratungskontakt, 'termin', mini=1, maxi=2)
        form.str(Beratungskontakt, 'no', format={
                'no':  "Notiz fr Beratungskontakt: {bkontid}",
                })
        #print 'BKONTEINF', form
        return form

    def leisteinf(self, **kw):
        """ """
        assert 'fallid' in kw
        assert 'bg' in kw
        #print 'FSEINF', kw['fallid']
        fall = Fall(kw['fallid']) 
        stz = fall['zustaendig__mit__stz']
        form = Form(self, **kw)
        form.id(Leistung, ('id', 'leistid'), newid=True)
        form.id(Fall, ('id', 'fallid'))
        #print 'LEISTEINF', kw['stz']
        form.id(Mitarbeiter, ('id', 'mitid'), stz=stz, benr='bearb', stat='i')
        form.code(Leistung, 'le', 'stz', values={'stz':stz})
        form.date(Leistung, 'bg')
        form.date(Leistung, 'e', value=Date(0,0,0))
        return form
    def perseinf(self, **kw):
        assert 'akid' in kw
        form = Form(self, **kw)
        form.id(Bezugsperson, ('id', 'bpid'), newid=True)
        form.id(Akte, ('id', 'akid'))
        form.code(Bezugsperson, 'verw', 'gs', 'fs', 'nobed', 'vrt')
        form.str(Bezugsperson, 'vn', 'na', 'ber', 'tl1', 'tl2', 'mail', 'no',
                 id_key='bpid',
                 format={
                        'vn': 'Bezugsperson{bpid}Vn',
                        'na': 'Bezugsperson{bpid}Na',
                        'no': 'Notiz fr Bezugsperson: {bpid}',
                        'tl1': '01{int2} {int4} {int4}',
                        'tl2': '0{int3}/{int4} {int4}',
                        })
        form.adresse(Bezugsperson, 'str', 'hsnr', 'plz', 'plraum', 'lage', 'ort', 'strkat_on')
        form.date(Bezugsperson, 'gb', 
                  mini=Date(1930,1,1),
                  maxi=self.bis_jahr.add_month(-240),
                  )
        return form
    def einreinf(self, **kw):
        assert 'akid' in kw
        form = Form(self, **kw)
        form.id(Einrichtungskontakt, ('id', 'einrid'), newid=True)
        form.id(Akte, ('id', 'akid'))
        form.code(Einrichtungskontakt, 'insta', 'nobed', 'status')
        form.str(Einrichtungskontakt, 'na', 'tl1', 'tl2', 'mail', 'no',
                 id_key='einrid',
                 format={
                        'na': 'Einrichtung{einrid}Vn',
                        'no': 'Notiz fr Einrichtung: {einrid}',
                        'tl1': '01{int2} {int4} {int4}',
                        'tl2': '0{int3}/{int4} {int4}',
                        'mail': 'einr{einrid}@einrichtung.com',
                        })
        return form

    def codeeinf(self, **kw):
        assert 'katcode' in kw or 'katid' in kw
        assert 'code' in kw
        assert 'name' in kw
        assert 'sort' in kw
        if 'katcode' in kw:
            kw['katid'] = Kategorie(code=kw['katcode'])['id']
        elif 'katid' in kw:
            kw['katcode'] = Kategorie(kw['katid'])['code']
        form = Form(self, **kw)
        form.id(Code, ('id', 'codeid'), newid=True)
        form.id(Kategorie, ('id', 'katid'))
        form.str(Code, 'code', 'katcode', 'name', 'dok', 'view', values={
                'dok': '',
                'view': 'codelist',
                })
        form.integer(Code, 'mini', 'maxi', 'off', 'sort', values={
                'mini': None,
                'maxi': None,
                'off': 0,
                })
        return form
    def updcode(self, **kw):
        if 'codeid' not in kw:
            assert 'kat_code' in kw
            assert 'code' in kw
            kw['codeid'] = Code(code=kw['code'],kat_code=kw['kat_code'])['id']
        form = Form(self, **kw)
        form.id(Code, ('id', 'codeid'))
        form.id(Kategorie, ('id', 'kat_id'), values={
                'kat_id': None,
                })
        form.str(Code, 'kat_code', 'code', 'name', 'dok', 'view', values={
                'kat_code': None,
                'code': None,
                'name': None,
                'dok': None,
                'view': 'codelist',
                })
        form.integer(Code, 'mini', 'maxi', 'off', 'sort', values={
                'mini': None,
                'maxi': None,
                'off': 0,
                'sort': None,
                })
        if 'd' not in kw:
            form['dm'] = ''
            form['dy'] = ''
        else:
            form.date(Code, 'd')
        return form
    def fseinf(self, **kw):
        assert 'fallid' in kw
        assert 'jahr' in kw
        #print 'FSEINF', kw['fallid']
        form = Form(self, **kw)
        form.id(Fachstatistik, ('id', 'fsid'), newid=True)
        form.id(Fall, ('id', 'fallid'))
        fall = Fall(form['fallid'])
        #print 'FALL', form['fallid'], fall
        #print 'FSEINF FORM', form
        akte = Akte(fall['akte_id'])
        form.str(Fachstatistik, 'fall_fn', 'no', 'no2', 'no3', 'plr', format={
                'fall_fn': fall['fn'],
                'no': 'Fachstatistiknotiz {fsid}',
                'no2': 'anders geartete Problemlagen Kind Notiz {fsid}',
                'no3': 'anders geartete Problemlagen Eltern Notiz {fsid}',
                }) 
        form.id(Mitarbeiter, ('id', 'mitid'), value=fall['zustaendig__mit_id'])
        form.integer(Fachstatistik, 'jahr')
        alter = calc_age(akte['gb'], fall.getDate('bg'))
        def altersgruppe():
            ag = cc('fsag','999')
            try:
                ag = bcode('fsag', alter)['id']
            except:
                pass # kein bereich gefunden
            return ag
        form.code(Fachstatistik, 'stz', 'gs', 'ag', 'fs', 'zm', 'qualij', 'hkm', 'hkv', 'bkm', 'bkv', 
                  'qualikm', 'qualikv', 'agkm', 'agkv', 'ba1', 'ba2', 'pbe', 'pbk', 
                  'anmprobleme', 'elternprobleme', 'kindprobleme', 'eleistungen', 
                  'joka1', 'joka2', 'joka3', 'joka4',
                  'jokf5', 'jokf6', 'jokf7', 'jokf8',
                  values={
                'stz': akte['stzbg'],
                'gs': akte['gs'],
                'ag': altersgruppe()})
        form.integer(Fachstatistik, 'kkm', 'kkv', 'kki', 'kpa', 'kfa',
                     'ksoz', 'kleh', 'kerz', 'kkonf','kson', 
                     mini=0, maxi=10)
        form.integer(Fachstatistik, 'kat', value=sum(
                [form[x] 
                 for x in ('kkv', 'kki', 'kpa', 'kfa',
                           'ksoz', 'kleh', 'kerz', 'kkonf','kson',)]))
        # TEST
        # print "FSEINF:"
        # for k,v in form.items(): print "{:<10} {}".format(k,v)
        return form
    def updfskonfig(self, **kw):
        """Defaultverhalten wenn kw leer ist:
        - alle Items inklusive Joker aktiviert, dh es werden Daten fr alle Items geschickt.
        - Bei Joker die default Labels und Kategorien
        - Item deaktivieren: joka3_a=None
        Beispiel:
        updfskonfig(jokf5_a=1,          # aktiviert
                    jokf5_l='Probleme', # label
                    jok5_k='problk',    # kat_code
                    jok5_m=1            # falls da und wert=1, multi, sonst single
        """
        from ebkus.html.fskonfig import fs_customize as fsc
        re_jok = re.compile(r'jok(a|f)(\d+)')
        label = {'a': "Frei definierbar unter Angaben zum Klienten",
                 'f': "Frei definierbar eigenstndig" }
        form = Form(self, **kw)
        for f in fsc.abschaltbare_items:
            f_obj = fsc.get(f)
            fname = '%s_a' % f
            if not (fname in kw and kw.get('fname') is None):
                form[fname] = '1'
            if f in fsc.joker_felder:
                typ, nr = re_jok.match(f).groups()
                # Label
                fname = '%s_l' % f
                lbl = kw.get(fname)
                if not lbl:
                    lbl = label[typ]
                form[fname] = lbl
                # Kat_code
                fname = '%s_k' % f
                kat = kw.get(fname)
                if kat:
                    kat_id = form._get_id_for_name(kat, Kategorie)
                else:
                    kat_id = Kategorie(code='fsjok{0}{1}'.format(typ, nr))['id']
                form[fname] = kat_id
                # Multi
                fname = '%s_m' % f
                multi = kw.get(fname)
                if multi == 1:
                    form[fname] = 1
                # Default ist Nicht-Multi, kein Wert in der Form
        return form
    def jgh07einf(self, **kw):
        assert 'fallid' in kw
        assert 'jahr' in kw
        assert 'e' in kw # Endedatum, falls abgeschlossen, None, falls andauernd
        if kw['e'] is None:
            kw['hda'] = cc('ja_nein', '1')
        else:
            kw['hda'] = cc('ja_nein', '2')
        form = Form(self, **kw)
        form.id(Jugendhilfestatistik2007, ('id', 'jghid'), newid=True)
        form.id(Fall, ('id', 'fallid'))
        fall = Fall(form['fallid'])
        akte = Akte(fall['akte_id'])
        form.id(Mitarbeiter, ('id', 'mitid'), value=fall['zustaendig__mit_id'])
        form.str(Jugendhilfestatistik2007, 'fall_fn', 'zustw', values={
                'fall_fn': fall['fn'],
                'zustw': choice(('1', None)) # 
                }) 
        form.integer(Jugendhilfestatistik2007, 'jahr')
        form.code(Jugendhilfestatistik2007, 
                  'stz', 'land', 'kr', 'einrnr', 'gfall', 'gef8a', 'hilf_art', 'hilf_ort', 
                  'traeger', 'gs', 'aort_vor', 'sit_fam', 'ausl_her', 'vor_dt', 'wirt_sit', 
                  'ees', 'va52', 'rgu', 'hda', 'inobh42_22',
                  values={
                      'stz': akte['stzbg'],
                      'gs': akte['gs'],
                      'land': Code(kat_code='land', sort=1)['id'],
                      'kr': Code(kat_code='kr', sort=1)['id'], # zustndige Stelle!
                      'einrnr': Code(kat_code='einrnr', sort=1)['id'], # zustndige Stelle!
                      'inobh42_22': Code(kat_code='inobh42', code='1')['id'],
                })
        if form['gef8a'] == cc('ja_nein', '1'): #ja 
            form.code(Jugendhilfestatistik2007, 'aip', value=cc('aip', '4')) # Soziale/r Dienst/e und andere Institution/en
        else:
            form.code(Jugendhilfestatistik2007, 'aip')
        # Gruende passen nicht ins Schema, daher zu Fu
        gruende = self.choose_code_id_several('gruende', 1, 3, unique=True)
        form['gr1'] = gruende[0]
        if len(gruende) > 1:
            form['gr2'] = gruende[1]
            if len(gruende) > 2:
                form['gr3'] = gruende[2]
        form.date(Jugendhilfestatistik2007, 'ge', 'bg', values={
                'ge': akte['gb'],
                'bg': fall.getDate('bg'),
                })
        if form['hda'] == cc('ja_nein', '1'):
            form.integer(Jugendhilfestatistik2007, 'nbkakt', mini=1, maxi=30)
        else:
            form.code(Jugendhilfestatistik2007, 'lbk6m', 'grende', 'aort_nac', 'unh')
            form.integer(Jugendhilfestatistik2007, 'nbkges', mini=1, maxi=50)
            form.date(Jugendhilfestatistik2007, 'e')
        return form
    def altdaten(self):
        """Einen Datensatz Altdaten erzeugen."""
        # TODO
        # Adresse. So ist gewhrleistet, dass die Addressdaten je nach config aus dem Straenkatalog kommen
        form = Form(self, **{})
        form.adresse(Akte, 'str', 'hsnr', 'plz', 'ort')
        # aus der Zeit von (self.von_jahr - 5) bis (self.von_jahr - 1)
        von = self.von_jahr.year
        jahr = str(randrange(von - 5, von))
        id=Altdaten().getNewId()
        altd = Altdaten()
        altd.init(
            id=id,
            vorname=choice(self.vornamen),
            name=choice(self.nachnamen),
            geburtsdatum=str(self.choose_date(Date(von-25, 3, 1), Date(von-2, 3, 1))),
            geschlecht=choice(('m', 'w')),
            jahr=jahr,
            fallnummer=("%s%03d" % (jahr, choice(range(1,1000)))),
            mitarbeiter="Mitarb%s" % id,
            strasse=form['str'],
            hausnummer=form['hsnr'],
            plz=form['plz'],
            ort=form['ort'],
            # strasse=choice(self.strassen),
            # hausnummer=str(randrange(1, 200)),
            # plz=str(randrange(10000, 99999)),
            # ort=choice(self.orte),
            telefon1=str(randrange(10001, 99999999)),
            telefon2=str(randrange(10001, 99999999)),
            memo=("Memo fr Altdaten id=%s. "
            " Hier kann man noch eine Menge ber den alten Fall reinschreiben. "
            "Auch lngere Texte. " % id)[:randrange(25,150)]
            )
        return altd
    def altdaten_einfuegen_und_beispiel_datei_erzeugen(self, n_altdaten):
        """Die Tabelle altdaten wird gefllt und die csv-Datei der Altdaten 
        wird in das Homeverzeichnis der Instanz geschrieben.
        """
        fields = [f['feld'] for f in FeldList(
            where="tabelle.tabelle='altdaten'",
            join=[('tabelle', 'tabelle.id=feld.tab_id')])][1:]
        csv_path = os.path.join(self.config.INSTANCE_HOME, 'beispiel_altdaten.csv')
        #print 'CSV_PATH', csv_path
        csv_file = open(csv_path, 'wb')
        csv_file.write(';'.join(['"%s"' % f for f in fields]) + '\r\n')
        for i in range(1, n_altdaten):
            altd = self.altdaten()
            csv = ';'.join([('"%%(%s)s"' % a) % altd for a in fields])
            csv_file.write(csv + '\r\n')
            altd.insert()
        csv_file.close()
        self.log('Altdaten CSV generiert: %s' % csv_path)

    def choose_code(self, kat_code):
        """Niemals 'keine Angabe' liefern"""
        codes = get_codes(kat_code)
        assert [x for x in codes if x != '999'], 'Codes alle 999'
        while True:
            code = choice(codes)
            if code['code'] != '999':
                return code
    def choose_code_id(self, kat_code):
        return self.choose_code(kat_code)['id']
    def choose_code_id_several(self, kat_code, min, max, unique=False):
        codes = get_codes(kat_code)
        how_many = randrange(min, max+1)
        selection = sample(codes, how_many)
        if not unique:
            selection_2 = sample(codes, how_many)
            n = how_many / 2
            # auf diese Weise knnen welche doppelt auftauchen
            selection = selection[:n] + selection_2[n:]
        return [c['id'] for c in selection]
    def choose_date(self, mini=None, maxi=None):
        maxi = str2date(maxi)
        mini = str2date(mini)
        if not maxi:
            maxi = today()
        if not mini:
            mini = Date(today().year - 2)
        #log("CHOOSE_DATE min/max: %s/%s" % (min,max))
        assert maxi >= mini
        assert mini != Date(0,0,0)
        assert maxi != Date(0,0,0)
        maxi = maxi.to_py_date()
        mini = mini.to_py_date()
        from datetime import timedelta
        date = mini + timedelta(days=randint(0, (maxi - mini).days))
        return Date(date.year, date.month, date.day)


class TestError(Exception):
    pass
class WrongData(TestError):
    pass
class WrongPage(TestError):
    pass
class NoTitle(TestError):
    pass
class NotStatus200(TestError):
    pass
class EBKuSError(TestError):
    pass
class EBKuSInternalError(TestError):
    pass
class NoAccess(TestError):
    pass
class NotAuthorized(TestError):
    pass


class Interact(object):
    def __init__(self, verbose=0):
        self.verbose = verbose
        from ebkus.config import config
        self.config = config
        self.test_instanz = self.config.INSTANCE_NAME
    def set_today(self, date):
        self.login('Admin', 'Admin')
        self.set_config_vars(today=date, login=False)
        self.logout()



# Die http-Tests funktionier nur, wenn das Pythonpaket requests in der Version 2.2.1 oder 2.3.0 installiert ist.
# Hhere Versionen funktionieren nicht, ich habe nicht verstanden warum nicht.
# Nach dem logout, das ein Redirect mit location: login generiert, antwortet requests > 2.3.0 mit pwchange
# anstatt mit login. Das fhr auf eine Seite 'Zugriff verweigert'.

class InteractHttp(Interact):
    _re_akid_fallid_persneu = re.compile(ur'persneu\?akid=(?P<akte_id>\d+)&fallid=(?P<fall_id>\d+)&klerv=')
    _re_akid_fallid_waufnneu = re.compile(ur'waufnneu\?akid=(?P<akte_id>\d+)&fallid=(?P<fall_id>\d+)"')
    _re_akid_fallid_zdar = re.compile(ur"go_to_url\('zdar\?akid=(?P<akte_id>\d+)&fallid=(?P<fall_id>\d+)'")
    _re_fehler = re.compile(ur'<fieldset><legend class="legendtext">Fehlerbeschreibung</legend>')
    _re_title = re.compile(ur'<title>(?P<title>.+?)</title>', re.IGNORECASE)
    _re_zugriff_verweigert = re.compile(ur'<fieldset><legend class="legendtext">Zugriff verweigert</legend>')
    _re_konfig_name_konfig_var = re.compile(ur"""updkonfig\?konfig_name=(?P<konfig_name>)">.+</td>.*<td class="tabledata">(?P=konfig_name)</td><td class="tabledata">(?P<konfig_value>)</td>""", re.MULTILINE)
    _re_konfig_var = re.compile(ur"""updkonfig\?konfig_name={konfig_name}">.+</td>.*<td class="tabledata">(konfig_name)</td><td class="tabledata">(?P<konfig_value>)</td>""")


    path = {
        'miteinf': 'mitausw',
        'akteeinf': 'klkarte',
        'leisteinf': 'klkarte',
        'fseinf': 'klkarte',
        'jgh07einf': 'klkarte',
        'zdaeinf': 'klkarte',
        'zdareinf': 'klkarte',
        'waufneinf': 'klkarte',
        'perseinf': 'klkarte',
        'einreinf': 'klkarte',
        'bkonteinf': 'klkarte',
        'codeeinf': 'admin',
        'updcode': 'admin',
        'updfskonfig': 'admin',
        }
    title = {
        'miteinf': 'Mitarbeiter',
        'akteeinf': 'Klientenkarte',
        'leisteinf': 'Klientenkarte',
        'fseinf': 'Klientenkarte',
        'jgh07einf': 'Klientenkarte',
        'zdaeinf': 'Klientenkarte',
        'zdareinf': 'Klientenkarte',
        'waufneinf': 'Klientenkarte',
        'perseinf': 'Klientenkarte',
        'einreinf': 'Klientenkarte',
        'bkonteinf': 'Klientenkarte',
        'codeeinf': 'Kategorien und Merkmalslisten',
        'updcode': 'Kategorien und Merkmalslisten',
        #'updfskonfig': 'Administratorhauptmen',
        #'updfskonfig': u'Administratorhauptmen',
        'updfskonfig': 'nderung durchgef',
        }
    def __init__(self, **kw):
        super(InteractHttp, self).__init__(**kw)
        self.session = None
    def submit(self, test_daten, file, **kw):
        form = getattr(test_daten, file)(file=file, **kw)
        if self.verbose > 1:
            print file.upper(), form
        #print 'DO_UPDATE HTTP', file.upper()
        r = self.session.post(self.url + self.path[file], data=form, verify=False)
        #print 'NACH POST:',r.text
        self.check_error(r, is_in_title=self.title[file])
        return form
    def altdaten(self, n_altdaten):
        raise NotImplementedError("altdaten()")
    @property
    def base_url(self):
        try:
            # Alte Ebkus-Versionen hatten das nicht
            port = self.config.SERVER_HTTPS_PORT
        except AttributeError:
            port = 443
        server_name = self.config.SERVER_NAME
        if server_name == '0.0.0.0':
            server_name = 'localhost'
        url = "https://{0}{1}/ebkus/{2}/".format(
            server_name,
            "" if port == 443 else (':'+str(port)),
            self.test_instanz,
            )
        return url
    @property
    def url(self):
        return self.base_url + 'cgi/do/'
    def set_config_vars(self, login=True, **kw):
        if login:
            self.login('Admin', 'Admin')
        from ebkus.app.ebapi import Date
        for k, v in kw.items():
            setattr(self.config, k.upper(), v)
            if isinstance(v, bool):
                v = {True: 'true', False: 'false'}[v]
            if isinstance(v, (int, long)):
                v = str(v)
            if isinstance(v, (int, long, Date)):
                v = str(v)
            kl = k.lower()
            r = self.session.post(self.url + 'konfigausw', data={
                    'konfig_name': kl, 
                    'konfig_value': v, 
                    'konfig_all': '1', 
                    'file': 'updkonfig',
                    }, verify=False)
            self.check_error(r, is_in_title='Konfiguration')
            #print r.text.encode('utf8')
        if login:
            self.logout()
    def login(self, user, passw):
        import requests
        import urllib3
        urllib3.disable_warnings(urllib3.exceptions.InsecureRequestWarning)
        # import logging
        # import httplib

        # httplib.HTTPConnection.debuglevel = 1

        # logging.basicConfig()
        # logging.getLogger().setLevel(logging.DEBUG)
        # requests_log = logging.getLogger("requests.packages.urllib3")
        # requests_log.setLevel(logging.DEBUG)
        # requests_log.propagate = True
        session = requests.Session()
        url = self.url + 'login'
        data = {'username': user, 'pass': passw}
        if self.verbose > 1:
            print 'URL:', url
            print 'DATA:', data
        r = session.post(url, data=data, verify=False)
        #print 'R.TEXT', r.text
        self.check_error(r, is_in_title='Benutzerpasswortes')
        self.session = session
    def logout(self):
        # Versuch mit requests >= 2.4.0, da das hier nicht mehr funktioniert
        # Ging aber letzlich auch nicht, Ursache mir nicht klar
        #r = self.session.get(self.url + 'logout', allow_redirects=False, verify=False)
        # if r.status_code != 301:
        #     raise NotStatus200("HTTP Status: {0} (Erwartet: 301)".format(r.status_code))

        r = self.session.get(self.url + 'logout', verify=False)
        self.check_error(r, is_in_title='EBKuS Benutzeranmeldung')
        self.session = None
    def check_error(self, r, is_in_title=None):
        if r.status_code != 200:
            raise NotStatus200("HTTP Status: {0}".format(r.status_code))
        if self._re_zugriff_verweigert.search(r.text):
            raise NoAccess(r.text)
        res = self.match(self._re_title, r.text, title=True)
        if res:
            title = res['title']
        else:
            raise NoTitle(r.text)
        if self._re_fehler.search(r.text):
            if title == 'Interner Fehler':
                raise EBKuSInternalError(r.text)
            elif title == 'Fehlermeldung':
                raise EBKuSError(r.text)
        if is_in_title:
            if is_in_title not in title:
                raise WrongPage(' [String "' + is_in_title + '" <ist nicht in> "' + title + '"]\n' + r.text)
    def get_letzter_fall_id(self, akte_id):
        r = self.session.get(self.url + 'klkarte', params={'akid': akte_id}, verify=False)
        res = self.match(self._re_akid_fallid_persneu, r.text, akte_id=str(akte_id), fall_id=True)
        if not res:
            res = self.match(self._re_akid_fallid_waufnneu, r.text, akte_id=str(akte_id), fall_id=True)
        if not res:
            res = self.match(self._re_akid_fallid_zdar, r.text, akte_id=str(akte_id), fall_id=True)
        return int(res['fall_id'])
    def match(self, regex, text, **kw):
        """Jeder Parameter in kw ist der Name einer Gruppe in regex.
        Falls der Wert True ist, muss es einen nicht leeren Match geben.
        Sonst muss der Wert ein String sein. Der muss gleich sein mit
        dem Wert der matchenden Gruppe.
        Alle matchenden Gruppen werden als dict zurckgegeben.
        Wenn kein match gefunden, None zurckgeben.
        """
        aT = self.assertTrue
        res = {}
        match = regex.search(text)
        # print '*********************MATCHED TEXT (type: {0})***********************'.format(type(text))
        # print 'Pattern:', regex.pattern, 'type: ', type(regex.pattern)
        # print text
        # print '*********************END MATCHED TEXT*******************'
        if not match:
            #print text
            return None
        for k,v in kw.items():
            val = match.group(k)
            res[k] = val
            if v is True:
                aT(val)
            else:
                assert isinstance(v, basestring)
                aT(val == v)
        return res
        

def get_traceback():
    import traceback
    s = ''.join(traceback.format_exception(*sys.exc_info()))
    return s

class InteractEbupd(Interact):
    def __init__(self, **kw):
        super(InteractEbupd, self).__init__(**kw)
        from ebkus.app import ebupd
        self.ebupd = ebupd
    def set_config_vars(self, **kw):
        from ebkus.app.ebapi import Date
        for k, v in kw.items():
            if isinstance(v, Date):
                v = str(v)
            setattr(self.config, k.upper(), v)
    def login(self, user, passw):
        pass
    def logout(self):
        pass
    def submit(self, test_daten, file, **kw):
        from ebkus.db.sql import SQLError
        from ebkus.db.dbadapter import DatabaseError
        from ebkus.db.dbapp import DBAppError
        from ebkus.app.ebapi import EBUpdateError, EBUpdateDataError
        form = getattr(test_daten, file)(file=file, **kw)
        if self.verbose > 1:
            print file.upper(), form
        #print 'DO_UPDATE EBUPD', file.upper()
        try:
            getattr(self.ebupd, file)(form)
            return form
        except (DatabaseError, DBAppError, SQLError), e:
            # ist nie von Anwender zu verantworten, also ein interner Fehler
            raise EBKuSInternalError("Datenbankfehler: \n%s" % get_traceback())
        except EBUpdateDataError, e:
            # in der Regel ausgelst durch die Eingaben des Anwenders
            raise EBKuSError(str(e))
        except EBUpdateError, e:
            # schwerer Fehler, der geloggt werden soll
            raise EBKuSInternalError(get_traceback())
        except Exception, e:
            # ist nie (wenn doch, ist es ein Bug) vom Anwender zu verantworten,
            raise EBKuSInternalError(get_traceback())
            
    
    def get_letzter_fall_id(self, akte_id):
        from ebkus.app.ebapi import Akte
        akte = Akte(akte_id)
        letzter_fall = akte['letzter_fall']
        return letzter_fall['id']


