# coding: latin-1

"""Module fr die Klientenkarte."""
# TODO an die Standards anpassen
import re, time
from ebkus.config import config
from ebkus.app import Request
from ebkus.app import ebupd
from ebkus.app import ebapi
from ebkus.app.ebapi import Code, Date, today
import ebkus.html.htmlgen as h
from ebkus.html.akte_share import akte_share

class klkarte(Request.Request, akte_share):
    """Klientenkarte."""
    permissions = Request.KLKARTE_PERM
    def processForm(self, REQUEST, RESPONSE):
        #print 'KLIENTENKATE FORM', sorted([i for i in dict(self.form).items()])
        file = self.form.get('file')
        # Fall 1 Klientenkarte direkt darstellen
        if not file or file == 'klkarte':
            fallid = self.form.get('fallid')
            akid = self.form.get('akid')
            if not akid:
                if fallid:
                    akid = ebapi.Fall(fallid)['akte_id']
                else:
                    raise ebapi.EE('Es wurde nichts aus dem Men ausgewhlt.')
            if self.is_post:
                RESPONSE.redirect('klkarte?akid=%s' % akid, status=303)
                return ''
            else:
                return self.klkarte_display(akid)
            
            # Fall 2 erst einfuegen oder updaten, dann Klientenkarte darstellen
        if self.einfuege_oder_update_operationen.get(file):
            akid = self.einfuegen_oder_update(file)
            # damit Klientenkarte nicht als Ergebnis eines POST
            # dargestellt wird
            RESPONSE.redirect('klkarte?akid=%s' % akid, status=303)
            return ''

            # Fall 3 Dokumenten- Update- oder Einfuegeformular anzeigen
            # Folgende URLs haben denselben Effekt:
            # 1)  http://localhost/efb/ebs/klkarte?file=akteneu
            # 2)  http://localhost/efb/ebs/akteneu
            # Variante 1) ntzlich wg. Aufruf aus menu.
            # Knnte auch mit redirect gelst werden.
            
        if file == 'kldok':
            fallid = self.form.get('fallid')
            if fallid:
                    fallid = int(fallid)
            else:
                raise ebapi.EE('Es wurde nichts aus dem Men ausgewhlt.')
            RESPONSE.redirect('kldok?fallid=%s' % fallid, status=303)
            return ''
        # fr die Behandlung der Statistiken vom Hauptmen aus:
        if file in ('updjghform', 'updfsform', 'vorblatt', 'vorblattpdf'):
            fallid = self.form.get('fallid')
            if not fallid:
                raise ebapi.EE('Es wurde nichts aus dem Men ausgewhlt.')
            fall = ebapi.Fall(fallid)
            if file == 'updjghform':
                jgh = fall['jgh'] # in ebapi definiert
                if not jgh:
                    file = 'jgh07neu'
            elif file == 'updfsform':
                if not fall['fachstatistiken']:
                    file = 'fsneu'
            # vorblatt geht an dispatch
            # wie schafft man es an dieser Stelle, dass ein
            # neuer Fenster fr das Vorblatt aufgemacht wird?
        return self.ebkus.dispatch(file, REQUEST, RESPONSE)
        
    einfuege_oder_update_operationen = {
      'akteeinf': ('akid', ebapi.Akte),
      'perseinf': ('akid', ebapi.Akte),
      'einreinf': ('akid', ebapi.Akte),
      'anmeinf': ('fallid', ebapi.Fall),
      'leisteinf': ('fallid', ebapi.Fall),
      'bkonteinf': ('fallid', ebapi.Fall),
      'wirebeinf': ('fallid', ebapi.Fall),
      #'updwireb': ('fallid', ebapi.Fall),
      'removewireb': ('wirebid', ebapi.Wireb),
      'removebkont': ('fallid', ebapi.Fall),
      'zusteinf': ('fallid', ebapi.Fall),
      'zdaeinf': ('fallid', ebapi.Fall),
      #'updfall': ('gfall', ebapi.Fall),
      'updakte': ('akid', ebapi.Akte),
      'updpers': ('bpid', ebapi.Bezugsperson),
      'removepers': ('bpid', ebapi.Bezugsperson),
      'updeinr': ('einrid', ebapi.Einrichtungskontakt),
      'removeeinr': ('einrid', ebapi.Einrichtungskontakt),
      'updanm': ('anmid', ebapi.Anmeldung),
      'updleist': ('leistid', ebapi.Leistung),
      'removeleist': ('leistid', ebapi.Leistung),
      'updbkont': ('fallid', ebapi.Fall),
      'updzust': ('zustid', ebapi.Zustaendigkeit),
      'updfall': ('fallid', ebapi.Fall),
      'waufneinf': ('fallid', ebapi.Fall),
      'zdareinf': ('fallid', ebapi.Fall),
      'fseinf': ('fsid', ebapi.Fachstatistik),
      'updfs': ('fsid', ebapi.Fachstatistik),
      'jgh07einf': ('fallid', ebapi.Fall),
      'updjgh07': ('fallid', ebapi.Fall),
        'fseinf': ('fsid', ebapi.Fachstatistik),
        'zusaetzliche_mitarbeiter': ('fallid', ebapi.Fall),
      }
    
    def einfuegen_oder_update(self, file):
        # Akte id ermitteln um klkarte anzeigen zu knnen
        id_name, klass = self.einfuege_oder_update_operationen.get(file)
        akid = None
        if file.startswith('remove'):
            # vorher, weils Objekt spter weg ist
            akid = klass(int(self.form[id_name]))['akte__id']
        # API Funktion aufrufen
        function = getattr(ebupd, file)
        function(self.form)
        if not akid:
            akid = klass(int(self.form[id_name]))['akte__id']
        return akid
        
    def klkarte_display(self, akid):
        "Darstellung der Klientenkarte."
        
        akte = ebapi.Akte(akid)
        if akte['gesperrt']:
            raise ebapi.EE("Die Akte ist gesperrt. Der Anwendungsadministrator kann gegebenenfalls eine Entsperrung veranlassen.")
        bezugspersonen_list = akte['bezugspersonen']
        einrichtungskontakte_list = akte['einrichtungen']
        faelle = akte['faelle']
        
        faelle.sort('bgy', 'bgm', 'bgd')
        bezugspersonen_list.sort('verw__sort')
        einrichtungskontakte_list.sort('status', 'na')
        leistungen_list = []
        zustaendigkeiten_list = []
        beratungskontakte_list = []
        anmeldekontakte_list = []
        fachstatistik_list = []
        jugendhilfestatistik_list = []
        fallgruppen_list = []
        bezugspersongruppen_list = []
        for f in faelle:
            leistungen_list += f['leistungen']
            zustaendigkeiten_list += f['zustaendigkeiten']
            beratungskontakte_list += f['beratungskontakte']
            anmeldekontakte_list += f['anmeldung']
            fachstatistik_list += f['fachstatistiken']
            jugendhilfestatistik_list += f['jgh_statistiken']
            jugendhilfestatistik_list += f['jgh07_statistiken']
            fallgruppen_list +=  f['gruppen']
        for b in bezugspersonen_list:
            bezugspersongruppen_list += b['gruppen']
        letzter_fall = akte['letzter_fall']
        aktueller_fall = akte['aktueller_fall']
        wiederaufnehmbar =  akte['wiederaufnehmbar']
        
        menu = h.FieldsetInputTable(daten=[[
            h.Button(value="Hauptmen",
                     tip="Zum Hauptmen",
                     onClick="go_to_url('menu')",
                     ),
            h.Button(value="Klientendokumente",
                     class_='buttonbig',
                     tip="Klientendokumente ansehen",
                     onClick="go_to_url('kldok?akid=%(id)s')" % akte,
                     ),
            self.get_button_klienten_neu(aktueller_fall, wiederaufnehmbar, letzter_fall),
            self.get_button_klienten_anzeige(aktueller_fall, letzter_fall),
            ]])

        klientendaten = self.get_klientendaten_readonly(
            akte, 
            button=aktueller_fall and
            h.Button(value="Bearbeiten",
                     tip="Klientenstammdaten bearbeiten",
                     onClick= "go_to_url('updakte?akid=%(id)s')" % akte)
            or None,
            )
        bezugspersonen = self.get_bezugspersonen(bezugspersonen_list, aktueller_fall,
                                                 edit_button=True, view_button=True,
                                                 hinzufuegen_button=True)
        leistungen = h.FieldsetDataTable(
            legend= 'Leistungen',
            headers= ('Mitarbeiter', 'Leistung', 'Am', 'Bis'),
            noheaders=2,
            daten= [[aktueller_fall == leist['fall'] and
                      h.Icon(href= 'updleist?fallid=%(fall_id)d&leistid=%(id)d' % leist,
                           icon= "/ebkus/ebkus_icons/edit_button.gif",
                           tip= 'Leistung bearbeiten')
                     or h.Dummy(),
                     aktueller_fall == leist['fall'] and
                     h.Icon(href= 'rmleist?&leistid=%(id)d' % leist,
                            icon= "/ebkus/ebkus_icons/del_button.gif",
                            tip= 'Leistung lschen')
                     or h.Dummy(),
                     h.String(string= leist['mit_id__na']),
                     h.String(string= leist['le__name']),
                     h.Datum(date=leist.getDate('bg')),
                     h.Datum(date=leist.getDate('e')),
                     ]
                    for leist in leistungen_list],
            button= (aktueller_fall and
                     h.Button(value= "Hinzufgen",
                            tip= "Leistung hinzufgen",
                         onClick= "go_to_url('leistneu?akid=%(id)d&fallid=%(aktueller_fall__id)d')" % akte,
                            ) or None),
            )

        if config.BERATUNGSKONTAKTE:
            # auch fr Braunschweig
            beratungskontakte = self.get_beratungskontakte(beratungskontakte_list,
                                                           aktueller_fall=aktueller_fall,
                                                           edit_button=True,
                                                           view_button=True,
                                                           hinzufuegen_button=True,
                                                           akte=akte)
        else:
            beratungskontakte = None
        button_gen = _WaOrZdaOrBeides(config.WIEDERAUFNAHMEFRIST,
                                      config.ZDA_RUECKGAENGIG_FRIST,
                                      config.ZDA_RUECKGAENGIG_BIS,
                                      letzter_fall.getDate('zda'),
                                      today())
        tip_wiederaufnahme = "Beratung wiederaufnehmen mit neuer Fallnummer"
        if button_gen.zdar_unterbunden:
            tip_wiederaufnahme += " (Kein ZdA rckgngig mehr mglich nach dem {})".format(button_gen.zda_rueckgaengig_bis)
        stand = h.FieldsetDataTable(
            legend= 'Stand',
            headers= ('Fallnummer', 'Anmeldedatum', 'z.d.A.'),
            noheaders=1,
            daten= [[fall == aktueller_fall and
                      h.Icon(href= 'updfall?akid=%(akte_id)d&fallid=%(id)d' % fall,
                           icon= "/ebkus/ebkus_icons/edit_button.gif",
                           tip= 'Fallstatus bearbeiten')
                      or h.Dummy(),
                     h.String(string=fall['fn']),
                     h.Datum(day=fall['bgd'],
                           month= fall['bgm'],
                           year=  fall['bgy']),
                     h.Datum(day=fall['zdad'],
                           month= fall['zdam'],
                           year=  fall['zday'])]
                    for fall in faelle],
            buttons=button_gen.get_buttons(h.Button(
                    value= "Zu den Akten",
                    tip= "Fall abschlieen",
                    onClick= "go_to_url('zda?akid=%(akte_id)s&fallid=%(id)d')" % letzter_fall,),
                                           h.Button(
                    value= "ZdA rckgngig",
                    tip= "Fall reaktivieren, Fortsetzung mit vorhandener Fallnummer",
                    onClick= "go_to_url('zdar?akid=%(akte_id)s&fallid=%(id)d')" % letzter_fall,),
                                           h.Button(
                    value= "Wiederaufnahme",
                    tip= tip_wiederaufnahme,
                    onClick= "go_to_url('waufnneu?akid=%(akte_id)s&fallid=%(id)d')" % letzter_fall,),
                                           )
            )
        bearbeiter = h.FieldsetDataTable(
            legend= 'Bearbeiter',
            headers= ('Bearbeiter', 'Beginn', 'Ende'),
            noheaders=1,
            daten= [[zust['fall'] == aktueller_fall and
                      h.Icon(href= 'updzust?fallid=%(fall_id)d&zustid=%(id)d' % zust,
                           icon= "/ebkus/ebkus_icons/edit_button.gif",
                           tip= "Zustndigkeit bearbeiten")
                      or h.Dummy(),
                     h.String(string= zust['mit_id__na']),
                     h.Datum(day=   zust['bgd'],
                           month= zust['bgm'],
                           year=  zust['bgy']),
                     h.Datum(day=zust['ed'],
                           month= zust['em'],
                           year=  zust['ey'])]
                    for zust in zustaendigkeiten_list],
            button=(aktueller_fall and
                    h.Button(value= "Hinzufgen",
                           tip= "Neue Zustndigkeit eintragen",
                           onClick= "go_to_url('zustneu?akid=%(akte_id)s&fallid=%(id)d')" % aktueller_fall,)
                    or None),
            )
        anmeldekontakt_daten = [[aktueller_fall == a['fall'] and
                                 h.Icon(href= 'updanm?anmid=%(id)d' % a,
                                        icon= "/ebkus/ebkus_icons/edit_button.gif",
                                        tip= 'Anmeldekontakt bearbeiten')
                                 or h.Dummy(),
                                 h.String(string= a['von']),
                                 h.String(string= a['mtl']),
                                 h.String(string= a['zm__name']),
                                 h.String(string= a['me']),
                                 h.Datum(date=a['fall'].getDate('bg')),
                                 h.String(string= a['mg']),
                                 h.String(string= a['no']),
                                 ]
                                for a in anmeldekontakte_list]
        if aktueller_fall and config.ANMELDEPROBLEME_UND_BESCHAEFTIGUNG_BEI_ANMELDUNG_ERFASSEN:
            anm = aktueller_fall['anmeldung']
            if anm:
                anm = anm[0]
                try:
                    cell = []
                    for name in [Code(int(i))['name'] for i in anm['anmprobleme'].split()]:
                        cell.append(name)
                    anmeldekontakt_daten.append([h.Dummy()] + [h.String(n_col=3,string="Problem(e) bei der Anmeldung:")] + [h.String(n_col=4,string='<br/>'.join(cell))])
                except AttributeError:
                    pass # Wenn noch keine Daten da sind
        anmeldekontakte = h.FieldsetDataTable(
            legend= 'Anmeldekontakte',
            headers= ('Gemeldet von', 'Telefon', 'Empf.', 'durch', 
                      'Gemeldet am', 'Anmeldegrund', 'Notiz'),
            noheaders=1,
            daten=anmeldekontakt_daten,
            button= (aktueller_fall and not aktueller_fall['anmeldung'] and
                     h.Button(value= "Hinzufgen",
                            tip= "Anmeldungskontakt hinzufgen",
                            onClick=
                            "go_to_url('anmneu?fallid=%(id)d')" % aktueller_fall,
                            ) or None),
            )

        einrichtungskontakte = h.FieldsetDataTable(
            legend= 'Einrichtungskontakte',
            headers= ('Art', 'Name', 'Telefon 1', 'Telefon 2', 'E-Mail', 'Aktuell', 'Notiz'),
            noheaders=2,
            daten= [[aktueller_fall and
                     h.Icon(href= 'updeinr?einrid=%(id)d' % e,
                            icon= "/ebkus/ebkus_icons/edit_button.gif",
                            tip= 'Einrichtungskontakt bearbeiten')
                     or h.Dummy(),
                     aktueller_fall and
                      h.Icon(href= 'rmeinr?einrid=%(id)d' % e,
                             icon= "/ebkus/ebkus_icons/del_button.gif",
                             tip= 'Einrichtungskontakt lschen')
                     or h.Dummy(),
                     h.String(string= e['insta__name']),
                     h.String(string= e['na']),
                     h.String(string= e['tl1']),
                     h.String(string= e['tl2']),
                     h.String(string= e['mail_link']),
                     h.String(string= e['status__code']),
                     h.String(string= e['no'],
                              class_=ebapi.cc('notizbed', 't')==e['nobed'] and 'tabledatared'
                                     or 'tabledata'
                              ),
                     ]
                    for e in einrichtungskontakte_list],
            button= (aktueller_fall and
                     h.Button(value= "Hinzufgen",
                            tip= "Einrichtungskontakt hinzufgen",
                            onClick=
                            "go_to_url('einrneu?fallid=%(id)d')" % aktueller_fall,
                            ) or None),
            )

        notiz_daten = []
        if akte['no']:
            notiz_daten.append([h.String(string= 'AK'),
                          h.String(string= "%(vn)s %(na)s" % akte),
                          h.String(string= akte['no']),
                          h.String(string= ''),
                          ])
        for b in bezugspersonen_list:
            if b['no']:
                notiz_daten.append([h.String(string= 'BP'),
                              h.String(string= "%(vn)s %(na)s" % b),
                              h.String(string= b['no']),
                              h.String(string= b['nobed__name'],
                                     class_=ebapi.cc('notizbed', 't')==b['nobed'] and 'tabledatared'
                                     or 'tabledata'),
                              ])
        for e in einrichtungskontakte_list:
            if e['no']:
                notiz_daten.append([h.String(string= 'ER'),
                              h.String(string= "%(insta__name)s %(na)s" % e),
                              h.String(string= e['no']),
                              h.String(string= e['nobed__name'],
                                     class_=ebapi.cc('notizbed', 't')==e['nobed'] and 'tabledatared'
                                     or 'tabledata'),
                              ])
        for a in anmeldekontakte_list:
            if a['no']:
                notiz_daten.append([h.String(string= 'AM'),
                              h.String(string= "%(von)s" % a),
                              h.String(string= a['no']),
                              h.String(string= ''),
                              ])
            
        notizen = h.FieldsetDataTable(
            legend= 'Notizen',
            daten= notiz_daten,
            button=None,
            )

        fachstatistik = h.FieldsetDataTable(
            legend= 'Fachstatistiken',
            headers= ('Fallnummer', 'Jahr',),
            daten= [[h.Icon(href= 'updfs?fsid=%(id)d' % fs,
                          icon= "/ebkus/ebkus_icons/edit_stat_button.gif",
                          tip= 'Fachstatistik bearbeiten'),
                     h.Icon(href= 'viewfs?fsid=%(id)d' % fs,
                            target='_blank',
                            icon= "/ebkus/ebkus_icons/view_details.gif",
                            tip= 'Fachstatistik ansehen/drucken'),
                     h.String(string= fs['fall_fn']),
                     h.String(string= fs['jahr'])]
                    for fs in fachstatistik_list],
            button= (aktueller_fall and not aktueller_fall['fachstatistiken'] and
                     h.Button(value= "Hinzufgen",
                            tip= "Fachstatistik hinzufgen",
                            onClick=
                            "go_to_url('fsneu?fallid=%(id)d')" % aktueller_fall,
                            ) or None),
            )
        jugendhilfestatistik_list = []
        for f in faelle:
            for js in f['jgh_statistiken']:
                if js['ey']: # warum diese Prfung?
                    js['action'] = 'updjgh07'
                    jugendhilfestatistik_list.append(js)
            for js in f['jgh07_statistiken']:
                if js['bgy']: # warum diese Prfung?
                    js['action'] = 'updjgh07'
                    jugendhilfestatistik_list.append(js)
        if config.KEINE_BUNDESSTATISTIK:
            jugendhilfestatistik = ''
        else:
            jugendhilfestatistik = h.FieldsetDataTable(
                legend= 'Jugendhilfestatistiken',
                headers= ('Fallnummer', 'Ende'),
                daten= [[h.Icon(href= '%(action)s?jghid=%(id)d' % js,
                                icon= "/ebkus/ebkus_icons/edit_stat_button.gif",
                                tip= 'Jugendhilfestatistik bearbeiten'),
                         h.String(string= js['fall_fn']),
                         h.Datum(month= js['em'],
                               year=  js['ey'])]
                        for js in jugendhilfestatistik_list],
                button= (aktueller_fall and
                         not (aktueller_fall['jgh_statistiken'] or
                              aktueller_fall['jgh07_statistiken']) and
                         h.Button(value= "Hinzufgen",
                                tip= "Jugendhilfestatistik hinzufgen",
                                onClick=
                                "go_to_url('jgh07neu?fallid=%(id)d')" % aktueller_fall,
                                ) or None),
                )

        wireb = ''
        if config.WIREB:
            alle_wireb_fuer_akte = [f['wireb'][0] for f in faelle if f['wireb']]
            # Kein Fieldset auf der Klientenkarte, wenn weder aktueller Fall
            # noch alte Anbindungen vorhanden
            if aktueller_fall or alle_wireb_fuer_akte:
                wireb = h.FieldsetDataTable(
                    legend = 'Wir.EB',
                    headers = ('Fallnummer', 'Wir.EB-Fallcodenummer', 'angelegt am', 'Jugendhilfestatistik hochgeladen', 'Evaluationsbgen ausgefllt'),
                    noheaders = 2,
                    daten = [[h.Icon(href= 'wireb?wirebid=%(id)d' % w,
                                     icon= "/ebkus/ebkus_icons/edit_stat_button.gif",
                                     tip= 'Wir.EB-Fall bearbeiten')
                              if aktueller_fall == w['fall'] 
                              else h.Dummy(),
                              h.Icon(href= 'wireb?wirebid=%(id)d&file=removewireb' % w,
                                     icon= "/ebkus/ebkus_icons/del_button.gif",
                                     tip= 'Wir.EB-Anbindung lschen') 
                              if aktueller_fall == w['fall'] 
                              else h.Dummy(),
                              h.String(string= w['fall__fn']),
                              h.String(string= w['fallcodenummer']),
                              h.Datum(date= w.getDate('fcbg')),
                              h.Datum(date= w.getDate('jghbg')) if w['jghbgy'] else
                              h.String(string='nein',
                                       align='center'),
                              h.String(string='ja' if w['alle_bearbeitet__code'] == '1' else 'nein')
                              ] for w in alle_wireb_fuer_akte],
                    button = (aktueller_fall and not aktueller_fall['wireb'] and 
                              h.Button(value="Hinzufgen",
                                       tip="Mit diesem Fall an Wir.EB teilnehmen ('Wirkungsevaluation in der Erziehungsberatung')",
                                       onClick=
                                       "go_to_url('wireb?fallid=%(id)d&file=wirebeinf')" % aktueller_fall,
                                       ) or None),
                    )
        bezugspersongruppen = fallgruppen = ''
        if fallgruppen_list:
            fallgruppen = h.FieldsetDataTable(
                legend='Gruppenkarten des Falls',
                headers=('Gruppennummer', 'Name',),
                noheaders=1,
                daten=[[aktueller_fall
                         and
                         h.Icon(href='grkarte?gruppeid=%(gruppe_id)s' % fg,
                              icon="/ebkus/ebkus_icons/edit_grp_button.gif",
                              tip='Gruppenkarte ansehen')
                         or h.Dummy(),
                        h.String(string=fg['gruppe_id__gn']),
                        h.String(string="%(fall__akte__vn)s %(fall__akte__na)s" % fg)]
                       for fg in fallgruppen_list],
                )
        if bezugspersongruppen_list:
            bezugspersongruppen = h.FieldsetDataTable(
                legend= 'Gruppenkarten der Bezugspersonen',
                headers= ('Gruppennummer.', 'Name',),
                noheaders=1,
                daten= [[aktueller_fall and
                          h.Icon(href= 'grkarte?gruppeid=%(gruppe_id)s' % bg,
                               icon= "/ebkus/ebkus_icons/edit_grp_button.gif",
                               tip= 'Gruppenkarte ansehen')
                          or h.Dummy(),
                         h.String(string= bg['gruppe_id__gn']),
                         h.String(string= "%(bezugsp__vn)s %(bezugsp__na)s" % bg)]
                        for bg in bezugspersongruppen_list],
                )
        if (aktueller_fall and config.ZUSAETZLICHE_BERECHTIGUNGEN):
            zusaetzlich_berechtigte_list = [
                h.String(string=zb['mit__name']) for zb in
                ebapi.ZusaetzlicheBerechtigungList(where='fall_id = {}'.format(
                    aktueller_fall['id']))]
            if (len(zusaetzlich_berechtigte_list) % 2) != 0:
                zusaetzlich_berechtigte_list.append('')
            it = iter(zusaetzlich_berechtigte_list)
            zusaetzlich_berechtigte_pairs = zip(it, it)
            zusaetzliche_berechtigte = h.FieldsetDataTable(
                legend="Zustzlich Berechtigte",
                headers= ('Mitarbeiter', '', '', ''),
                daten= [[name1, name2]
                        for name1, name2 in zusaetzlich_berechtigte_pairs],
                button= h.Button(
                    value= "Bearbeiten",
                    tip= "Liste der berechtigten Mitarbeiter bearbeiten",
                    onClick= "go_to_url('updzusber?fallid={}')".format(aktueller_fall['id']),
                ),
            )
        else:
            zusaetzliche_berechtigte = None
        rows = [
            menu,
            klientendaten,
            bezugspersonen,
            beratungskontakte,
            leistungen,
            h.Pair(left=stand,
                   right=bearbeiter),
            anmeldekontakte,
            einrichtungskontakte,
            h.Pair(left=fachstatistik,
                   right=jugendhilfestatistik),
            wireb,
            notizen,
            h.Pair(left=fallgruppen,
                   right=bezugspersongruppen),
            zusaetzliche_berechtigte,
            ]
        extern = self.get_extern_fieldset(akte)
        if extern:
            rows.insert(config.EXTERN_FIELDSET_POSITION, extern)
        res = h.Page(
            title='Klientenkarte',
            name="",action="",method="",hidden=(),
            help=True,
            breadcrumbs = (('Hauptmen', 'menu'),
                           ),
            rows=rows,
            )
        return res.display()

    def _interpolate_external_url(self, url, fall, mitarbeiter):
        """Urls knnen Abschnitte der folgenden Form enthalten:
        $$<fall oder mitarbeiter>_<feld>$$
        Der ganze Abschnitt wird durch den Wert von <feld> ersetzt, 
        wobei entweder im fall-Objekt oder im Mitarbeiter-Objekt 
        nachgeschlagen wird. 
        Beispiele:
        $$fall_id$$, $$mitarbeiter_na$$, $$fall_akte__ort$$
        """
        params = re.findall(r"\$\$(mitarbeiter|fall)_(\w+)\$\$", url)
        value = None
        for prefix, key in params:
            if prefix == 'fall':
                value = fall[key]
            elif prefix == 'mitarbeiter':
                value = mitarbeiter[key]
            if value != None:
                url = url.replace('$$%s_%s$$' % (prefix, key), str(value))
        return url

    def get_extern_fieldset(self, akte):
        if not config.EXTERN_FIELDSET_LABEL:
            return None
        letzter_fall = akte['letzter_fall']
        aktueller_fall = akte['aktueller_fall']
        if aktueller_fall:
            fall = aktueller_fall
        else:
            fall = letzter_fall
        extern_data = []
        for i in range(1, 5):
            url = getattr(config, "EXTERN_BUTTON%s_URL" % i, None)
            url = self._interpolate_external_url(url, fall, self.mitarbeiter)
            label = getattr(config, "EXTERN_BUTTON%s_LABEL" % i, None)
            if url and label:
                extern_data.append((label, url))
        fieldset = h.FieldsetInputTable(
            legend=config.EXTERN_FIELDSET_LABEL,
            daten=[[
            h.Button(value=label,
                     onClick="go_to_url('newXX %s')" % (url,),
                     )
            for label, url in extern_data
            ]])
        if extern_data:
            return fieldset
        return None

class _WaOrZdaOrBeides(object):
    """"
    testbares Einzelobjekt fr Wiederaufnahme vs. zdaR-Logik
    >>> o = _WaOrZdaOrBeides(6, 6, Date(2020,2,10), Date(2019,12,10), Date(2020,7,30)) 
    >>> o.get_has_buttons()
    (False, False, True)
    >>> o = _WaOrZdaOrBeides(6, 6, Date(2020,2,10), Date(2019,12,10), Date(2020,7,30)) 
    >>> o.has_zda_button()
    False
    >>> o.has_zdar_button()
    False
    >>> o.has_wa_button()
    True
    >>> o = _WaOrZdaOrBeides(6, 6, Date(2020,2,10), Date(0,0,0), Date(2020,7,30)) 
    >>> o.has_zda_button()
    True
    >>> o.get_buttons(1,2,3)
    [1]
    >>> o = _WaOrZdaOrBeides(6, 6, Date(2020,2,10), Date(2019,12,21), Date(2020,2,9)) 
    >>> o.get_has_buttons()
    (False, True, False)
    >>> o = _WaOrZdaOrBeides(6, 6, Date(2020,2,10), Date(2019,12,21), Date(2020,2,10)) 
    >>> o.get_has_buttons()
    (False, True, False)
    >>> o = _WaOrZdaOrBeides(6, 6, Date(2020,2,10), Date(2019,12,21), Date(2020,2,11)) 
    >>> o.get_has_buttons()
    (False, False, True)
    >>> o = _WaOrZdaOrBeides(6, 6, '', Date(2019,12,21), Date(2020,2,11)) 
    >>> o.get_has_buttons()
    (False, True, False)
    >>> o = _WaOrZdaOrBeides(6, 6, '', Date(2019,12,21), Date(2020,6,21)) 
    >>> o.get_has_buttons()
    (False, True, False)
    >>> o = _WaOrZdaOrBeides(6, 6, '', Date(2019,12,21), Date(2020,6,22)) 
    >>> o.get_has_buttons()
    (False, False, True)
    >>> o = _WaOrZdaOrBeides(0, 0, '', Date(2019,12,21), Date(2020,1,22)) 
    >>> o.get_has_buttons()
    (False, False, True)
    >>> o = _WaOrZdaOrBeides(0, 0, '', Date(2019,12,21), Date(2019,12,22)) 
    >>> o.get_has_buttons()
    (False, False, True)
    >>> o = _WaOrZdaOrBeides(0, 1, '', Date(2019,12,21), Date(2019,12,22)) 
    >>> o.get_has_buttons()
    (False, True, True)
    >>> o = _WaOrZdaOrBeides(0, 1, '', Date(2019,12,21), Date(2020,1,20)) 
    >>> o.get_has_buttons()
    (False, True, True)
    >>> o = _WaOrZdaOrBeides(0, 1, '15.1', Date(2019,12,21), Date(2020,1,18)) 
    >>> o.get_has_buttons()
    (False, False, True)
    >>> o = _WaOrZdaOrBeides(0, 1, '', Date(2019,12,21), Date(2020,1,21)) 
    >>> o.get_has_buttons()
    (False, True, True)
    >>> o = _WaOrZdaOrBeides(0, 1, '', Date(2019,12,21), Date(2020,1,22)) 
    >>> o.get_has_buttons()
    (False, False, True)
    >>> o = _WaOrZdaOrBeides(0, 1, '', Date(2019,12,21), Date(2020,1,22)) 
    >>> o.get_buttons(1,2,3)
    [3]
    """
    def __init__(self, wiederaufnahmefrist, zda_rueckgaengig_frist, zda_rueckgaengig_bis, zda_datum, heute):
        self.wiederaufnahmefrist = wiederaufnahmefrist
        # -1 ist der default, wenn nicht explizit vom Anwender ein Wert zugewiesen wurde.
        # Wenn beide Werte gleich sind, sollte alles so wie vorher aussehen: innerhalb der
        # Wiederaufnahmefrist der zdar-Button, dann der Wiederaufnahmefrist-Button.
        # Wenn die Werte verschieden sind, erhlt man eine Periode, in der es beide Buttons gibt,
        # so dass man die Wahl hat.
        if zda_rueckgaengig_frist < 0:
            zda_rueckgaengig_frist = wiederaufnahmefrist
        # Sonst gbe es eine Periode ohne Buttons
        assert zda_rueckgaengig_frist >= wiederaufnahmefrist
        self.zda_rueckgaengig_frist = zda_rueckgaengig_frist
        if zda_rueckgaengig_bis:
            if isinstance(zda_rueckgaengig_bis, basestring):
                d, m = zda_rueckgaengig_bis.split('.')[:2]
                zda_rueckgaengig_bis = Date(heute.year, int(m), int(d))
        self.zda_rueckgaengig_bis = zda_rueckgaengig_bis
        self.zda_datum = zda_datum
        self.heute = heute
        self.compute()
    def compute(self):
        self.has_buttons = [self.has_zda_button(), self.has_zdar_button(), self.has_wa_button()]
    def has_zda_button(self):
        """Offene Flle haben immer ein zdA-Button"""
        if self.zda_datum.year == 0:
            return True
        return False
    def has_wa_button(self):
        """
        Wenn die Wiederaufnahmefrist vorbei ist, gibt es immer einen Wiederaufnahme-Button.
        Evt. aber auch frher, wenn zdar wg. zda_rueckgaengig_bis nicht geht.
        """
        # das ist nur dann True, wenn wg. zda_rueckgaengig_bis kein zdar-Button da ist 
        self.zdar_unterbunden = False
        if self.zda_datum.year == 0:
            return False
        wafrist_ab_datum = self.zda_datum.add_month(self.wiederaufnahmefrist)
        if self.heute > wafrist_ab_datum:
            return True
        # zda_rueckgaengig_bis hat zugeschlagen,  wa springt ein
        if not self.has_zdar_button():
            self.zdar_unterbunden = True
            return True
        return False
    def has_zdar_button(self):
        """"
        Wenn die zda_rueckgaengig_frist vorbei ist, gibt es keinen zda_rueckgaengig-Button.
        Auch nicht, falls das zda im vergangen Jahr lag, und das zda_rueckgaengig_bis vorbei ist.
        """
        if self.zda_datum.year == 0:
            return False
        if (self.zda_datum.year < self.heute.year and self.zda_rueckgaengig_bis and 
            self.heute > self.zda_rueckgaengig_bis):
            return False
        # print 'ZDA_DATUM', self.zda_datum
        # print 'ZDA_RUECKGAENGIG_FRIST', self.zda_rueckgaengig_frist
        zda_rueckgaengig_frist_datum = self.zda_datum.add_month(self.zda_rueckgaengig_frist)
        if self.heute <= zda_rueckgaengig_frist_datum:
            return True
        return False
    def get_buttons(self, zda, zdar, wa):
        buttons = []
        for button, switch in zip((zda,zdar,wa), self.has_buttons):
            if switch:
                buttons.append(button)
        return buttons
    def get_has_buttons(self):
        return tuple(self.has_buttons)
if __name__ == "__main__":
    import doctest
    doctest.testmod()
