#!/usr/bin/python
# coding: latin-1

"""
Passwort für User Admin auf Admin zurücksetzen.
Falls User Admin nicht existiert, ihn anlegen.
"""

import sys
import sha
import init
from ebkus.config import config

def usage():
    s = """\
reset_admin_passwort.py
    Passwort für Admin auf Admin setzen
"""    
    sys.exit(1)

def reset_passwort(user, passwort):
    from ebkus.app.ebapi import Mitarbeiter, MitarbeiterList, cc
    from ebkus.app.ebapih import get_codes
    from ebkus.db.sql import opendb, closedb, getDBHandle
    assert user == 'Admin'
    opendb()
    admins = MitarbeiterList(where="ben = '%s'" % user)
    if admins:
        admin = admins[0]
        update_dict = dict(
            benr = cc('benr', 'admin'),
            stat = cc('status', 'i'))
        update_dict['pass'] = sha.new(passwort).hexdigest()
        admin.update(update_dict)
    else:
        admin = Mitarbeiter()
        admin.init(
            id=Mitarbeiter().getNewId(),
            vn=user,
            na=user,
            ben=user,
            benr=cc('benr', 'admin'),
            stat=cc('status', 'i'),
            stz=get_codes('stzei')[0]['id'],
            )
        admin['pass'] = sha.new(passwort).hexdigest()
        admin.insert()

def main():
    # user = sys.argv[1]
    # passwort = sys.argv[2]
    # reset_passwort(user, passwort)
    user = 'Admin'
    passwort = 'Admin'
    print "Instanz: %s (%s)" % (config.INSTANCE_NAME, config.INSTANCE_TITLE)
    res = raw_input("Das Passwort für Benutzer '%s' auf den Wert '%s' zurücksetzen? (ja/nein): " % (user, passwort))
    if res.lower() == 'ja':
        reset_passwort('Admin', 'Admin')
        print "Das Passwort für Benutzer '%s' wurde auf den Wert '%s' zurückgesetzt" % (user, passwort)
    else:
        print "Passwort bleibt unverändert"
    
if __name__ == '__main__':
    if '--help' in sys.argv or '-h' in sys.argv:
        usage()
    main()

